﻿using System;
using Microsoft.Xna.Framework;
using RhythmComet;

namespace FMOD
{
    public enum SubBands
    {
        SubBass,
        LowBass,
        Bass,
        LowerMidrange,
        UpperMidrange,
        Presence,
        Treble,
        None
    }

    public interface IBeatManager : IGameComponent
    {
        SubBands LouderBand { get; }
        IBeatDetector[] Band { get; }
        void AddBand(int begin, int end, float deviation, float spawnTime, 
            float timeBufferLength);
        void Reset();
        bool Enabled { get; set; }
    }
}
