﻿using System;
using RhythmComet.Utils;
using Microsoft.Xna.Framework;
using System.Collections.Generic;

namespace FMOD
{
    public class RandomBeatManager : GameComponent, IBeatManager
    {
        private List<IBeatDetector> band;

        public RandomBeatManager(Game game) : base(game) 
        { 
            this.band = new List<IBeatDetector>(); 
        }

        #region IBeatManager Members

        public SubBands LouderBand
        {
            get { return (SubBands)RandomGenerator.RandomBetween(0, 6); }
        }

        public IBeatDetector[] Band
        {
            get { return band.ToArray(); }
        }

        public void AddBand(int begin, int end, float deviation, float spawnTime, float timeBufferLength)
        {
            this.band.Add(new RandomBeatDetector());
        }

        public void Reset()
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
