﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using FMOD;

namespace RhythmComet.Gameplay
{
    public struct ObstacleSettings
    {
        public int totalObstacles;
        public SubBands bandType;
        public float minSize;
        public float maxSize;
        public float minVerticalVelocity;
        public float maxVerticalVelocity;
        public float minHorizontalVelocity;
        public float maxHorizontalVelocity;
        public float maxHorizontalPosition;
        public float minHorizontalPosition;
        public float maxVerticalPosition;
        public float minVerticalPosition;
        public float rotationSpeed;

        public ObstacleSettings(SubBands bandType, int totalObstacles, float minSize, float maxSize, float minVerticalVelocity,
            float maxVerticalVelocity, float minHorizontalVelocity, float maxHorizontalVelocity, float maxHorizontalPosition,
            float minHorizontalPosition, float maxVerticalPosition, float minVerticalPosition, float rotationSpeed)
        {
            this.totalObstacles = totalObstacles;
            this.bandType = bandType;
            this.minSize = minSize;
            this.maxSize = maxSize;
            this.minVerticalVelocity = minVerticalVelocity;
            this.maxVerticalVelocity = maxVerticalVelocity;
            this.minHorizontalVelocity = minHorizontalVelocity;
            this.maxHorizontalVelocity = maxHorizontalVelocity;
            this.maxHorizontalPosition = maxHorizontalPosition;
            this.minHorizontalPosition = minHorizontalPosition;
            this.maxVerticalPosition = maxVerticalPosition;
            this.minVerticalPosition = minVerticalPosition;
            this.rotationSpeed = rotationSpeed;
        }
    }
}
