﻿/* ****************************************************************************
* Copyright (c) TCC - 2009 IME - USP. 
*
* This source code is subject to terms and conditions of the Microsoft Public License. 
* A copy of the license can be found in http://msdn.microsoft.com/en-us/library/dd228915.aspx. 
* By using this source code in any fashion, you are agreeing to be bound by the terms of the 
* Microsoft Public License.
*
* You must not remove this notice, or any other, from this software.
* ***************************************************************************/

using System;
using SoundLibrary.BeatDetection;
namespace SoundLibrary.Converter
{
    public class MP3Decoder
    {
        private BitStream stream;
        private Header header;
        private SynthesisFilter filter1, filter2;
        private OBuffer buffer;
        private BitReserve br;
        private III_side_info_t si;
        private temporaire2[] III_scalefac_t;
        private temporaire2[] scalefac;
        private SBI[] sfBandIndex;
        private Sftable sftable;
        private Equalizer equalizer;

        private int max_gr;
        private int frame_start;
        private int part2_start;
        private int channels;
        private int first_channel;
        private int last_channel;
        private int sfreq;
        private float[] samples1;
        private float[] samples2;
        private int[] new_slen;
        public int[] scalefac_buffer;
        private int CheckSumHuff = 0;
        private int[] is_1d;
        private float[][][] ro;
        private float[][][] lr;
        private float[] out_1d;
        private float[][] prevblck;
        private float[][] k;
        private int[] nonzero;
        private int which_channels;
        internal int[] x = new int[] { 0 };
        internal int[] y = new int[] { 0 };
        internal int[] v = new int[] { 0 };
        internal int[] w = new int[] { 0 };
        internal int[] is_pos;
        internal float[] is_ratio;
        internal float[] tsOutCopy;
        internal float[] rawout;
        private int counter = 0;
        private const int SSLIMIT = 18;
        private const int SBLIMIT = 32;
        private bool initialized;
        private static readonly int[][] slen = {
            new int[] { 0, 0, 0, 0, 3, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4 },
            new int[] { 0, 1, 2, 3, 0, 1, 2, 3, 1, 2, 3, 1, 2, 3, 2, 3 } };
        public static readonly int[] pretab = new int[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 3, 3, 3, 2, 0 };
        public static readonly float[] two_to_negative_half_pow = new float[] { 1.0000000000e+00f, 7.0710678119e-01f, 5.0000000000e-01f, 3.5355339059e-01f, 2.5000000000e-01f, 1.7677669530e-01f, 1.2500000000e-01f, 8.8388347648e-02f, 6.2500000000e-02f, 4.4194173824e-02f, 3.1250000000e-02f, 2.2097086912e-02f, 1.5625000000e-02f, 1.1048543456e-02f, 7.8125000000e-03f, 5.5242717280e-03f, 3.9062500000e-03f, 2.7621358640e-03f, 1.9531250000e-03f, 1.3810679320e-03f, 9.7656250000e-04f, 6.9053396600e-04f, 4.8828125000e-04f, 3.4526698300e-04f, 2.4414062500e-04f, 1.7263349150e-04f, 1.2207031250e-04f, 8.6316745750e-05f, 6.1035156250e-05f, 4.3158372875e-05f, 3.0517578125e-05f, 2.1579186438e-05f, 1.5258789062e-05f, 1.0789593219e-05f, 7.6293945312e-06f, 5.3947966094e-06f, 3.8146972656e-06f, 2.6973983047e-06f, 1.9073486328e-06f, 1.3486991523e-06f, 9.5367431641e-07f, 6.7434957617e-07f, 4.7683715820e-07f, 3.3717478809e-07f, 2.3841857910e-07f, 1.6858739404e-07f, 1.1920928955e-07f, 8.4293697022e-08f, 5.9604644775e-08f, 4.2146848511e-08f, 2.9802322388e-08f, 2.1073424255e-08f, 1.4901161194e-08f, 1.0536712128e-08f, 7.4505805969e-09f, 5.2683560639e-09f, 3.7252902985e-09f, 2.6341780319e-09f, 1.8626451492e-09f, 1.3170890160e-09f, 9.3132257462e-10f, 6.5854450798e-10f, 4.6566128731e-10f, 3.2927225399e-10f };
        public static readonly float[] t_43;
        public static readonly float[][] io = {
            new float[] { 1.0000000000e+00f, 8.4089641526e-01f, 7.0710678119e-01f, 5.9460355751e-01f, 5.0000000001e-01f, 4.2044820763e-01f, 3.5355339060e-01f, 2.9730177876e-01f, 2.5000000001e-01f, 2.1022410382e-01f, 1.7677669530e-01f, 1.4865088938e-01f, 1.2500000000e-01f, 1.0511205191e-01f, 8.8388347652e-02f, 7.4325444691e-02f, 6.2500000003e-02f, 5.2556025956e-02f, 4.4194173826e-02f, 3.7162722346e-02f, 3.1250000002e-02f, 2.6278012978e-02f, 2.2097086913e-02f, 1.8581361173e-02f, 1.5625000001e-02f, 1.3139006489e-02f, 1.1048543457e-02f, 9.2906805866e-03f, 7.8125000006e-03f, 6.5695032447e-03f, 5.5242717285e-03f, 4.6453402934e-03f },
            new float[] { 1.0000000000e+00f, 7.0710678119e-01f, 5.0000000000e-01f, 3.5355339060e-01f, 2.5000000000e-01f, 1.7677669530e-01f, 1.2500000000e-01f, 8.8388347650e-02f, 6.2500000001e-02f, 4.4194173825e-02f, 3.1250000001e-02f, 2.2097086913e-02f, 1.5625000000e-02f, 1.1048543456e-02f, 7.8125000002e-03f, 5.5242717282e-03f, 3.9062500001e-03f, 2.7621358641e-03f, 1.9531250001e-03f, 1.3810679321e-03f, 9.7656250004e-04f, 6.9053396603e-04f, 4.8828125002e-04f, 3.4526698302e-04f, 2.4414062501e-04f, 1.7263349151e-04f, 1.2207031251e-04f, 8.6316745755e-05f, 6.1035156254e-05f, 4.3158372878e-05f, 3.0517578127e-05f, 2.1579186439e-05f } };
        public static readonly float[] TAN12 = new float[] { 0.0f, 0.26794919f, 0.57735027f, 1.0f, 1.73205081f, 3.73205081f, 9.9999999e10f, -3.73205081f, -1.73205081f, -1.0f, -0.57735027f, -0.26794919f, 0.0f, 0.26794919f, 0.57735027f, 1.0f };
        private static int[][] reorder_table;
        private static readonly float[] cs = new float[] { 0.857492925712f, 0.881741997318f, 0.949628649103f, 0.983314592492f, 0.995517816065f, 0.999160558175f, 0.999899195243f, 0.999993155067f };
        private static readonly float[] ca = new float[] { -0.5144957554270f, -0.4717319685650f, -0.3133774542040f, -0.1819131996110f, -0.0945741925262f, -0.0409655828852f, -0.0141985685725f, -0.00369997467375f };
        public static readonly float[][] win = {
            new float[]{- 1.6141214951e-02f, - 5.3603178919e-02f, - 1.0070713296e-01f, - 1.6280817573e-01f, - 4.9999999679e-01f, - 3.8388735032e-01f, - 6.2061144372e-01f, - 1.1659756083e+00f, - 3.8720752656e+00f, - 4.2256286556e+00f, - 1.5195289984e+00f, - 9.7416483388e-01f, - 7.3744074053e-01f, - 1.2071067773e+00f, - 5.1636156596e-01f, - 4.5426052317e-01f, - 4.0715656898e-01f, - 3.6969460527e-01f, - 3.3876269197e-01f, - 3.1242222492e-01f, - 2.8939587111e-01f, - 2.6880081906e-01f, - 5.0000000266e-01f, - 2.3251417468e-01f, - 2.1596714708e-01f, - 2.0004979098e-01f, - 1.8449493497e-01f, - 1.6905846094e-01f, - 1.5350360518e-01f, - 1.3758624925e-01f, - 1.2103922149e-01f, - 2.0710679058e-01f, - 8.4752577594e-02f, - 6.4157525656e-02f, - 4.1131172614e-02f, - 1.4790705759e-02f}, 
			new float[]{- 1.6141214951e-02f, - 5.3603178919e-02f, - 1.0070713296e-01f, - 1.6280817573e-01f, - 4.9999999679e-01f, - 3.8388735032e-01f, - 6.2061144372e-01f, - 1.1659756083e+00f, - 3.8720752656e+00f, - 4.2256286556e+00f, - 1.5195289984e+00f, - 9.7416483388e-01f, - 7.3744074053e-01f, - 1.2071067773e+00f, - 5.1636156596e-01f, - 4.5426052317e-01f, - 4.0715656898e-01f, - 3.6969460527e-01f, - 3.3908542600e-01f, - 3.1511810350e-01f, - 2.9642226150e-01f, - 2.8184548650e-01f, - 5.4119610000e-01f, - 2.6213228100e-01f, - 2.5387916537e-01f, - 2.3296291359e-01f, - 1.9852728987e-01f, - 1.5233534808e-01f, - 9.6496400054e-02f, - 3.3423828516e-02f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f},
            new float[]{- 4.8300800645e-02f, - 1.5715656932e-01f, - 2.8325045177e-01f, - 4.2953747763e-01f, - 1.2071067795e+00f, - 8.2426483178e-01f, - 1.1451749106e+00f, - 1.7695290101e+00f, - 4.5470225061e+00f, - 3.4890531002e+00f, - 7.3296292804e-01f, - 1.5076514758e-01f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f},
            new float[]{0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, 0.0000000000e+00f, - 1.5076513660e-01f, - 7.3296291107e-01f, - 3.4890530566e+00f, - 4.5470224727e+00f, - 1.7695290031e+00f, - 1.1451749092e+00f, - 8.3137738100e-01f, - 1.3065629650e+00f, - 5.4142014250e-01f, - 4.6528974900e-01f, - 4.1066990750e-01f, - 3.7004680800e-01f, - 3.3876269197e-01f, - 3.1242222492e-01f, - 2.8939587111e-01f, - 2.6880081906e-01f, - 5.0000000266e-01f, - 2.3251417468e-01f, - 2.1596714708e-01f, - 2.0004979098e-01f, - 1.8449493497e-01f, - 1.6905846094e-01f, - 1.5350360518e-01f, - 1.3758624925e-01f, - 1.2103922149e-01f, - 2.0710679058e-01f, - 8.4752577594e-02f, - 6.4157525656e-02f, - 4.1131172614e-02f, - 1.4790705759e-02f}
        };
        public static readonly int[][][] nr_of_sfb_block = { new int[][] { new int[] { 6, 5, 5, 5 }, new int[] { 9, 9, 9, 9 }, new int[] { 6, 9, 9, 9 } }, new int[][] { new int[] { 6, 5, 7, 3 }, new int[] { 9, 9, 12, 6 }, new int[] { 6, 9, 12, 6 } }, new int[][] { new int[] { 11, 10, 0, 0 }, new int[] { 18, 18, 0, 0 }, new int[] { 15, 18, 0, 0 } }, new int[][] { new int[] { 7, 7, 7, 0 }, new int[] { 12, 12, 12, 0 }, new int[] { 6, 15, 12, 0 } }, new int[][] { new int[] { 6, 6, 6, 3 }, new int[] { 12, 9, 9, 6 }, new int[] { 6, 12, 9, 6 } }, new int[][] { new int[] { 8, 8, 5, 0 }, new int[] { 15, 12, 9, 0 }, new int[] { 6, 18, 9, 0 } } };

        /// <summary> adicao nossa auehduaehfarae
        private float[] ro_copy;
        public float[] Spectrum
        {
            get { return ro_copy; }
        }

        private BeatDetector beatDetector;
        /// </summary>

        #region Constructors
        static MP3Decoder()
        {
            t_43 = create_t_43();
        }

        public MP3Decoder(BitStream stream, Header header, OBuffer buffer, int which_ch, BeatDetector beatDetector)
        {
            this.stream = stream;
            this.header = header;
            this.buffer = buffer;
            this.which_channels = which_ch;
            this.initialized = false;
            this.beatDetector = beatDetector;
        }
        #endregion

        #region Private methods
        private void Initialize()
        {
            this.equalizer = new Equalizer();

            float scalefactor = 32700.0f;
            channels = header.Mode == Header.SINGLE_CHANNEL ? 1 : 2;

            this.filter1 = new SynthesisFilter(0, scalefactor, equalizer.BandFactors);
            if (channels == 2)
            {
                this.filter2 = new SynthesisFilter(1, scalefactor, equalizer.BandFactors);
            }

            rawout = new float[36];
            tsOutCopy = new float[18];
            is_ratio = new float[576];
            is_pos = new int[576];
            new_slen = new int[4];
            samples2 = new float[32];
            samples1 = new float[32];

            HuffmanTable.inithuff();
            is_1d = new int[SBLIMIT * SSLIMIT + 4];
            ro = new float[2][][];
            for (int i = 0; i < 2; i++)
            {
                ro[i] = new float[SBLIMIT][];
                for (int i2 = 0; i2 < SBLIMIT; i2++)
                {
                    ro[i][i2] = new float[SSLIMIT];
                }
            }
            lr = new float[2][][];
            for (int i3 = 0; i3 < 2; i3++)
            {
                lr[i3] = new float[SBLIMIT][];
                for (int i4 = 0; i4 < SBLIMIT; i4++)
                {
                    lr[i3][i4] = new float[SSLIMIT];
                }
            }
            out_1d = new float[SBLIMIT * SSLIMIT];
            prevblck = new float[2][];
            for (int i5 = 0; i5 < 2; i5++)
            {
                prevblck[i5] = new float[SBLIMIT * SSLIMIT];
            }
            k = new float[2][];
            for (int i6 = 0; i6 < 2; i6++)
            {
                k[i6] = new float[SBLIMIT * SSLIMIT];
            }
            nonzero = new int[2];

            III_scalefac_t = new temporaire2[2];
            III_scalefac_t[0] = new temporaire2();
            III_scalefac_t[1] = new temporaire2();
            scalefac = III_scalefac_t;

            sfBandIndex = new SBI[9];
            int[] l0 = new int[] { 0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 116, 140, 168, 200, 238, 284, 336, 396, 464, 522, 576 };
            int[] s0 = new int[] { 0, 4, 8, 12, 18, 24, 32, 42, 56, 74, 100, 132, 174, 192 };
            int[] l1 = new int[] { 0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 114, 136, 162, 194, 232, 278, 330, 394, 464, 540, 576 };
            int[] s1 = new int[] { 0, 4, 8, 12, 18, 26, 36, 48, 62, 80, 104, 136, 180, 192 };
            int[] l2 = new int[] { 0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 116, 140, 168, 200, 238, 284, 336, 396, 464, 522, 576 };
            int[] s2 = new int[] { 0, 4, 8, 12, 18, 26, 36, 48, 62, 80, 104, 134, 174, 192 };

            int[] l3 = new int[] { 0, 4, 8, 12, 16, 20, 24, 30, 36, 44, 52, 62, 74, 90, 110, 134, 162, 196, 238, 288, 342, 418, 576 };
            int[] s3 = new int[] { 0, 4, 8, 12, 16, 22, 30, 40, 52, 66, 84, 106, 136, 192 };
            int[] l4 = new int[] { 0, 4, 8, 12, 16, 20, 24, 30, 36, 42, 50, 60, 72, 88, 106, 128, 156, 190, 230, 276, 330, 384, 576 };
            int[] s4 = new int[] { 0, 4, 8, 12, 16, 22, 28, 38, 50, 64, 80, 100, 126, 192 };
            int[] l5 = new int[] { 0, 4, 8, 12, 16, 20, 24, 30, 36, 44, 54, 66, 82, 102, 126, 156, 194, 240, 296, 364, 448, 550, 576 };
            int[] s5 = new int[] { 0, 4, 8, 12, 16, 22, 30, 42, 58, 78, 104, 138, 180, 192 };

            int[] l6 = new int[] { 0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 116, 140, 168, 200, 238, 284, 336, 396, 464, 522, 576 };
            int[] s6 = new int[] { 0, 4, 8, 12, 18, 26, 36, 48, 62, 80, 104, 134, 174, 192 };
            int[] l7 = new int[] { 0, 6, 12, 18, 24, 30, 36, 44, 54, 66, 80, 96, 116, 140, 168, 200, 238, 284, 336, 396, 464, 522, 576 };
            int[] s7 = new int[] { 0, 4, 8, 12, 18, 26, 36, 48, 62, 80, 104, 134, 174, 192 };
            int[] l8 = new int[] { 0, 12, 24, 36, 48, 60, 72, 88, 108, 132, 160, 192, 232, 280, 336, 400, 476, 566, 568, 570, 572, 574, 576 };
            int[] s8 = new int[] { 0, 8, 16, 24, 36, 52, 72, 96, 124, 160, 162, 164, 166, 192 };

            sfBandIndex[0] = new SBI(l0, s0);
            sfBandIndex[1] = new SBI(l1, s1);
            sfBandIndex[2] = new SBI(l2, s2);

            sfBandIndex[3] = new SBI(l3, s3);
            sfBandIndex[4] = new SBI(l4, s4);
            sfBandIndex[5] = new SBI(l5, s5);

            sfBandIndex[6] = new SBI(l6, s6);
            sfBandIndex[7] = new SBI(l7, s7);
            sfBandIndex[8] = new SBI(l8, s8);


            if (reorder_table == null)
            {

                reorder_table = new int[9][];
                for (int i = 0; i < 9; i++)
                    reorder_table[i] = reorder(sfBandIndex[i].s);
            }


            int[] ll0 = new int[] { 0, 6, 11, 16, 21 };
            int[] ss0 = new int[] { 0, 6, 12 };
            sftable = new Sftable(this, ll0, ss0);

            scalefac_buffer = new int[54];

            frame_start = 0;
            //channels = (header.Mode == Header.SINGLE_CHANNEL) ? 1 : 2;
            max_gr = (header.Version == Header.MPEG1) ? 2 : 1;

            sfreq = header.SampleFrequency + ((header.Version == Header.MPEG1) ? 3 : (header.Version == Header.MPEG25_LSF) ? 6 : 0); // SZD

            if (channels == 2)
            {
                switch (which_channels)
                {

                    case (int)OutputChannelsEnum.LEFT_CHANNEL:
                    case (int)OutputChannelsEnum.DOWNMIX_CHANNELS:
                        first_channel = last_channel = 0;
                        break;


                    case (int)OutputChannelsEnum.RIGHT_CHANNEL:
                        first_channel = last_channel = 1;
                        break;


                    case (int)OutputChannelsEnum.BOTH_CHANNELS:
                    default:
                        first_channel = 0;
                        last_channel = 1;
                        break;
                }
            }
            else
            {
                first_channel = last_channel = 0;
            }

            for (int ch = 0; ch < 2; ch++)
                for (int j = 0; j < 576; j++)
                    prevblck[ch][j] = 0.0f;

            nonzero[0] = nonzero[1] = 576;

            br = new BitReserve();
            si = new III_side_info_t();

            // adicao nossa ehagoerwagoaerg
            ro_copy = new float[288];
            //

            this.initialized = true;
        }

        private bool get_side_info()
        {
            int ch, gr;
            if (header.Version == Header.MPEG1)
            {

                si.main_data_begin = stream.GetBits(9);
                if (channels == 1)
                    si.private_bits = stream.GetBits(5);
                else
                    si.private_bits = stream.GetBits(3);

                for (ch = 0; ch < channels; ch++)
                {
                    si.ch[ch].scfsi[0] = stream.GetBits(1);
                    si.ch[ch].scfsi[1] = stream.GetBits(1);
                    si.ch[ch].scfsi[2] = stream.GetBits(1);
                    si.ch[ch].scfsi[3] = stream.GetBits(1);
                }

                for (gr = 0; gr < 2; gr++)
                {
                    for (ch = 0; ch < channels; ch++)
                    {
                        si.ch[ch].gr[gr].part2_3_length = stream.GetBits(12);
                        si.ch[ch].gr[gr].big_values = stream.GetBits(9);
                        si.ch[ch].gr[gr].global_gain = stream.GetBits(8);
                        si.ch[ch].gr[gr].scalefac_compress = stream.GetBits(4);
                        si.ch[ch].gr[gr].window_switching_flag = stream.GetBits(1);
                        if ((si.ch[ch].gr[gr].window_switching_flag) != 0)
                        {
                            si.ch[ch].gr[gr].block_type = stream.GetBits(2);
                            si.ch[ch].gr[gr].mixed_block_flag = stream.GetBits(1);

                            si.ch[ch].gr[gr].table_select[0] = stream.GetBits(5);
                            si.ch[ch].gr[gr].table_select[1] = stream.GetBits(5);

                            si.ch[ch].gr[gr].subblock_gain[0] = stream.GetBits(3);
                            si.ch[ch].gr[gr].subblock_gain[1] = stream.GetBits(3);
                            si.ch[ch].gr[gr].subblock_gain[2] = stream.GetBits(3);

                            // Set region_count parameters since they are implicit in this case.

                            if (si.ch[ch].gr[gr].block_type == 0)
                            {
                                //	 Side info bad: block_type == 0 in split block
                                return false;
                            }
                            else if (si.ch[ch].gr[gr].block_type == 2 && si.ch[ch].gr[gr].mixed_block_flag == 0)
                            {
                                si.ch[ch].gr[gr].region0_count = 8;
                            }
                            else
                            {
                                si.ch[ch].gr[gr].region0_count = 7;
                            }
                            si.ch[ch].gr[gr].region1_count = 20 - si.ch[ch].gr[gr].region0_count;
                        }
                        else
                        {
                            si.ch[ch].gr[gr].table_select[0] = stream.GetBits(5);
                            si.ch[ch].gr[gr].table_select[1] = stream.GetBits(5);
                            si.ch[ch].gr[gr].table_select[2] = stream.GetBits(5);
                            si.ch[ch].gr[gr].region0_count = stream.GetBits(4);
                            si.ch[ch].gr[gr].region1_count = stream.GetBits(3);
                            si.ch[ch].gr[gr].block_type = 0;
                        }
                        si.ch[ch].gr[gr].preflag = stream.GetBits(1);
                        si.ch[ch].gr[gr].scalefac_scale = stream.GetBits(1);
                        si.ch[ch].gr[gr].count1table_select = stream.GetBits(1);
                    }
                }
            }
            else
            {
                // MPEG-2 LSF, SZD: MPEG-2.5 LSF

                si.main_data_begin = stream.GetBits(8);
                if (channels == 1)
                    si.private_bits = stream.GetBits(1);
                else
                    si.private_bits = stream.GetBits(2);

                for (ch = 0; ch < channels; ch++)
                {

                    si.ch[ch].gr[0].part2_3_length = stream.GetBits(12);
                    si.ch[ch].gr[0].big_values = stream.GetBits(9);
                    si.ch[ch].gr[0].global_gain = stream.GetBits(8);
                    si.ch[ch].gr[0].scalefac_compress = stream.GetBits(9);
                    si.ch[ch].gr[0].window_switching_flag = stream.GetBits(1);

                    if ((si.ch[ch].gr[0].window_switching_flag) != 0)
                    {

                        si.ch[ch].gr[0].block_type = stream.GetBits(2);
                        si.ch[ch].gr[0].mixed_block_flag = stream.GetBits(1);
                        si.ch[ch].gr[0].table_select[0] = stream.GetBits(5);
                        si.ch[ch].gr[0].table_select[1] = stream.GetBits(5);

                        si.ch[ch].gr[0].subblock_gain[0] = stream.GetBits(3);
                        si.ch[ch].gr[0].subblock_gain[1] = stream.GetBits(3);
                        si.ch[ch].gr[0].subblock_gain[2] = stream.GetBits(3);

                        // Set region_count parameters since they are implicit in this case.

                        if (si.ch[ch].gr[0].block_type == 0)
                        {
                            // Side info bad: block_type == 0 in split block
                            return false;
                        }
                        else if (si.ch[ch].gr[0].block_type == 2 && si.ch[ch].gr[0].mixed_block_flag == 0)
                        {
                            si.ch[ch].gr[0].region0_count = 8;
                        }
                        else
                        {
                            si.ch[ch].gr[0].region0_count = 7;
                            si.ch[ch].gr[0].region1_count = 20 - si.ch[ch].gr[0].region0_count;
                        }
                    }
                    else
                    {
                        si.ch[ch].gr[0].table_select[0] = stream.GetBits(5);
                        si.ch[ch].gr[0].table_select[1] = stream.GetBits(5);
                        si.ch[ch].gr[0].table_select[2] = stream.GetBits(5);
                        si.ch[ch].gr[0].region0_count = stream.GetBits(4);
                        si.ch[ch].gr[0].region1_count = stream.GetBits(3);
                        si.ch[ch].gr[0].block_type = 0;
                    }

                    si.ch[ch].gr[0].scalefac_scale = stream.GetBits(1);
                    si.ch[ch].gr[0].count1table_select = stream.GetBits(1);
                }
                // for(ch=0; ch<channels; ch++)
            }
            // if (header.Version == MPEG1)
            return true;
        }

        private void get_scale_factors(int ch, int gr)
        {
            int sfb, window;
            gr_info_s gr_info = (si.ch[ch].gr[gr]);
            int scale_comp = gr_info.scalefac_compress;
            int length0 = slen[0][scale_comp];
            int length1 = slen[1][scale_comp];

            if ((gr_info.window_switching_flag != 0) && (gr_info.block_type == 2))
            {
                if ((gr_info.mixed_block_flag) != 0)
                {
                    for (sfb = 0; sfb < 8; sfb++)
                        scalefac[ch].l[sfb] = br.Hgetbits(slen[0][gr_info.scalefac_compress]);
                    for (sfb = 3; sfb < 6; sfb++)
                        for (window = 0; window < 3; window++)
                            scalefac[ch].s[window][sfb] = br.Hgetbits(slen[0][gr_info.scalefac_compress]);
                    for (sfb = 6; sfb < 12; sfb++)
                        for (window = 0; window < 3; window++)
                            scalefac[ch].s[window][sfb] = br.Hgetbits(slen[1][gr_info.scalefac_compress]);
                    for (sfb = 12, window = 0; window < 3; window++)
                        scalefac[ch].s[window][sfb] = 0;
                }
                else
                {

                    scalefac[ch].s[0][0] = br.Hgetbits(length0);
                    scalefac[ch].s[1][0] = br.Hgetbits(length0);
                    scalefac[ch].s[2][0] = br.Hgetbits(length0);
                    scalefac[ch].s[0][1] = br.Hgetbits(length0);
                    scalefac[ch].s[1][1] = br.Hgetbits(length0);
                    scalefac[ch].s[2][1] = br.Hgetbits(length0);
                    scalefac[ch].s[0][2] = br.Hgetbits(length0);
                    scalefac[ch].s[1][2] = br.Hgetbits(length0);
                    scalefac[ch].s[2][2] = br.Hgetbits(length0);
                    scalefac[ch].s[0][3] = br.Hgetbits(length0);
                    scalefac[ch].s[1][3] = br.Hgetbits(length0);
                    scalefac[ch].s[2][3] = br.Hgetbits(length0);
                    scalefac[ch].s[0][4] = br.Hgetbits(length0);
                    scalefac[ch].s[1][4] = br.Hgetbits(length0);
                    scalefac[ch].s[2][4] = br.Hgetbits(length0);
                    scalefac[ch].s[0][5] = br.Hgetbits(length0);
                    scalefac[ch].s[1][5] = br.Hgetbits(length0);
                    scalefac[ch].s[2][5] = br.Hgetbits(length0);
                    scalefac[ch].s[0][6] = br.Hgetbits(length1);
                    scalefac[ch].s[1][6] = br.Hgetbits(length1);
                    scalefac[ch].s[2][6] = br.Hgetbits(length1);
                    scalefac[ch].s[0][7] = br.Hgetbits(length1);
                    scalefac[ch].s[1][7] = br.Hgetbits(length1);
                    scalefac[ch].s[2][7] = br.Hgetbits(length1);
                    scalefac[ch].s[0][8] = br.Hgetbits(length1);
                    scalefac[ch].s[1][8] = br.Hgetbits(length1);
                    scalefac[ch].s[2][8] = br.Hgetbits(length1);
                    scalefac[ch].s[0][9] = br.Hgetbits(length1);
                    scalefac[ch].s[1][9] = br.Hgetbits(length1);
                    scalefac[ch].s[2][9] = br.Hgetbits(length1);
                    scalefac[ch].s[0][10] = br.Hgetbits(length1);
                    scalefac[ch].s[1][10] = br.Hgetbits(length1);
                    scalefac[ch].s[2][10] = br.Hgetbits(length1);
                    scalefac[ch].s[0][11] = br.Hgetbits(length1);
                    scalefac[ch].s[1][11] = br.Hgetbits(length1);
                    scalefac[ch].s[2][11] = br.Hgetbits(length1);
                    scalefac[ch].s[0][12] = 0;
                    scalefac[ch].s[1][12] = 0;
                    scalefac[ch].s[2][12] = 0;
                }
            }
            else
            {
                if ((si.ch[ch].scfsi[0] == 0) || (gr == 0))
                {
                    scalefac[ch].l[0] = br.Hgetbits(length0);
                    scalefac[ch].l[1] = br.Hgetbits(length0);
                    scalefac[ch].l[2] = br.Hgetbits(length0);
                    scalefac[ch].l[3] = br.Hgetbits(length0);
                    scalefac[ch].l[4] = br.Hgetbits(length0);
                    scalefac[ch].l[5] = br.Hgetbits(length0);
                }
                if ((si.ch[ch].scfsi[1] == 0) || (gr == 0))
                {
                    scalefac[ch].l[6] = br.Hgetbits(length0);
                    scalefac[ch].l[7] = br.Hgetbits(length0);
                    scalefac[ch].l[8] = br.Hgetbits(length0);
                    scalefac[ch].l[9] = br.Hgetbits(length0);
                    scalefac[ch].l[10] = br.Hgetbits(length0);
                }
                if ((si.ch[ch].scfsi[2] == 0) || (gr == 0))
                {
                    scalefac[ch].l[11] = br.Hgetbits(length1);
                    scalefac[ch].l[12] = br.Hgetbits(length1);
                    scalefac[ch].l[13] = br.Hgetbits(length1);
                    scalefac[ch].l[14] = br.Hgetbits(length1);
                    scalefac[ch].l[15] = br.Hgetbits(length1);
                }
                if ((si.ch[ch].scfsi[3] == 0) || (gr == 0))
                {
                    scalefac[ch].l[16] = br.Hgetbits(length1);
                    scalefac[ch].l[17] = br.Hgetbits(length1);
                    scalefac[ch].l[18] = br.Hgetbits(length1);
                    scalefac[ch].l[19] = br.Hgetbits(length1);
                    scalefac[ch].l[20] = br.Hgetbits(length1);
                }

                scalefac[ch].l[21] = 0;
                scalefac[ch].l[22] = 0;
            }
        }

        private void get_LSF_scale_data(int ch, int gr)
        {

            int scalefac_comp, int_scalefac_comp;
            int mode_ext = header.ModeExtension;
            int m;
            int blocktypenumber;
            int blocknumber = 0;

            gr_info_s gr_info = (si.ch[ch].gr[gr]);

            scalefac_comp = gr_info.scalefac_compress;

            if (gr_info.block_type == 2)
            {
                if (gr_info.mixed_block_flag == 0)
                    blocktypenumber = 1;
                else if (gr_info.mixed_block_flag == 1)
                    blocktypenumber = 2;
                else
                    blocktypenumber = 0;
            }
            else
            {
                blocktypenumber = 0;
            }

            if (!(((mode_ext == 1) || (mode_ext == 3)) && (ch == 1)))
            {

                if (scalefac_comp < 400)
                {

                    new_slen[0] = (Util.URShift(scalefac_comp, 4)) / 5;
                    new_slen[1] = (Util.URShift(scalefac_comp, 4)) % 5;
                    new_slen[2] = Util.URShift((scalefac_comp & 0xF), 2);
                    new_slen[3] = (scalefac_comp & 3);
                    si.ch[ch].gr[gr].preflag = 0;
                    blocknumber = 0;
                }
                else if (scalefac_comp < 500)
                {

                    new_slen[0] = (Util.URShift((scalefac_comp - 400), 2)) / 5;
                    new_slen[1] = (Util.URShift((scalefac_comp - 400), 2)) % 5;
                    new_slen[2] = (scalefac_comp - 400) & 3;
                    new_slen[3] = 0;
                    si.ch[ch].gr[gr].preflag = 0;
                    blocknumber = 1;
                }
                else if (scalefac_comp < 512)
                {

                    new_slen[0] = (scalefac_comp - 500) / 3;
                    new_slen[1] = (scalefac_comp - 500) % 3;
                    new_slen[2] = 0;
                    new_slen[3] = 0;
                    si.ch[ch].gr[gr].preflag = 1;
                    blocknumber = 2;
                }
            }

            if ((((mode_ext == 1) || (mode_ext == 3)) && (ch == 1)))
            {
                int_scalefac_comp = Util.URShift(scalefac_comp, 1);

                if (int_scalefac_comp < 180)
                {
                    new_slen[0] = int_scalefac_comp / 36;
                    new_slen[1] = (int_scalefac_comp % 36) / 6;
                    new_slen[2] = (int_scalefac_comp % 36) % 6;
                    new_slen[3] = 0;
                    si.ch[ch].gr[gr].preflag = 0;
                    blocknumber = 3;
                }
                else if (int_scalefac_comp < 244)
                {
                    new_slen[0] = Util.URShift(((int_scalefac_comp - 180) & 0x3F), 4);
                    new_slen[1] = Util.URShift(((int_scalefac_comp - 180) & 0xF), 2);
                    new_slen[2] = (int_scalefac_comp - 180) & 3;
                    new_slen[3] = 0;
                    si.ch[ch].gr[gr].preflag = 0;
                    blocknumber = 4;
                }
                else if (int_scalefac_comp < 255)
                {
                    new_slen[0] = (int_scalefac_comp - 244) / 3;
                    new_slen[1] = (int_scalefac_comp - 244) % 3;
                    new_slen[2] = 0;
                    new_slen[3] = 0;
                    si.ch[ch].gr[gr].preflag = 0;
                    blocknumber = 5;
                }
            }

            for (int x = 0; x < 45; x++)
                // why 45, not 54?
                scalefac_buffer[x] = 0;

            m = 0;
            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < nr_of_sfb_block[blocknumber][blocktypenumber][i]; j++)
                {
                    scalefac_buffer[m] = (new_slen[i] == 0) ? 0 : br.Hgetbits(new_slen[i]);
                    m++;
                }

            }

        }

        private void get_LSF_scale_factors(int ch, int gr)
        {
            int m = 0;
            int sfb, window;
            gr_info_s gr_info = (si.ch[ch].gr[gr]);

            get_LSF_scale_data(ch, gr);

            if ((gr_info.window_switching_flag != 0) && (gr_info.block_type == 2))
            {
                if (gr_info.mixed_block_flag != 0)
                {
                    for (sfb = 0; sfb < 8; sfb++)
                    {
                        scalefac[ch].l[sfb] = scalefac_buffer[m];
                        m++;
                    }
                    for (sfb = 3; sfb < 12; sfb++)
                    {
                        for (window = 0; window < 3; window++)
                        {
                            scalefac[ch].s[window][sfb] = scalefac_buffer[m];
                            m++;
                        }
                    }
                    for (window = 0; window < 3; window++)
                        scalefac[ch].s[window][12] = 0;
                }
                else
                {
                    for (sfb = 0; sfb < 12; sfb++)
                    {
                        for (window = 0; window < 3; window++)
                        {
                            scalefac[ch].s[window][sfb] = scalefac_buffer[m];
                            m++;
                        }
                    }

                    for (window = 0; window < 3; window++)
                        scalefac[ch].s[window][12] = 0;
                }
            }
            else
            {
                for (sfb = 0; sfb < 21; sfb++)
                {
                    scalefac[ch].l[sfb] = scalefac_buffer[m];
                    m++;
                }
                scalefac[ch].l[21] = 0;
                scalefac[ch].l[22] = 0;
            }
        }

        private void hybrid(int ch, int gr)
        {
            int bt;
            int sb18;
            gr_info_s gr_info = (si.ch[ch].gr[gr]);
            float[] tsOut;

            float[][] prvblk;

            for (sb18 = 0; sb18 < 576; sb18 += 18)
            {
                bt = ((gr_info.window_switching_flag != 0) && (gr_info.mixed_block_flag != 0) && (sb18 < 36)) ? 0 : gr_info.block_type;

                tsOut = out_1d;

                for (int cc = 0; cc < 18; cc++)
                    tsOutCopy[cc] = tsOut[cc + sb18];

                inv_mdct(tsOutCopy, rawout, bt);


                for (int cc = 0; cc < 18; cc++)
                    tsOut[cc + sb18] = tsOutCopy[cc];

                prvblk = prevblck;

                tsOut[0 + sb18] = rawout[0] + prvblk[ch][sb18 + 0];
                prvblk[ch][sb18 + 0] = rawout[18];
                tsOut[1 + sb18] = rawout[1] + prvblk[ch][sb18 + 1];
                prvblk[ch][sb18 + 1] = rawout[19];
                tsOut[2 + sb18] = rawout[2] + prvblk[ch][sb18 + 2];
                prvblk[ch][sb18 + 2] = rawout[20];
                tsOut[3 + sb18] = rawout[3] + prvblk[ch][sb18 + 3];
                prvblk[ch][sb18 + 3] = rawout[21];
                tsOut[4 + sb18] = rawout[4] + prvblk[ch][sb18 + 4];
                prvblk[ch][sb18 + 4] = rawout[22];
                tsOut[5 + sb18] = rawout[5] + prvblk[ch][sb18 + 5];
                prvblk[ch][sb18 + 5] = rawout[23];
                tsOut[6 + sb18] = rawout[6] + prvblk[ch][sb18 + 6];
                prvblk[ch][sb18 + 6] = rawout[24];
                tsOut[7 + sb18] = rawout[7] + prvblk[ch][sb18 + 7];
                prvblk[ch][sb18 + 7] = rawout[25];
                tsOut[8 + sb18] = rawout[8] + prvblk[ch][sb18 + 8];
                prvblk[ch][sb18 + 8] = rawout[26];
                tsOut[9 + sb18] = rawout[9] + prvblk[ch][sb18 + 9];
                prvblk[ch][sb18 + 9] = rawout[27];
                tsOut[10 + sb18] = rawout[10] + prvblk[ch][sb18 + 10];
                prvblk[ch][sb18 + 10] = rawout[28];
                tsOut[11 + sb18] = rawout[11] + prvblk[ch][sb18 + 11];
                prvblk[ch][sb18 + 11] = rawout[29];
                tsOut[12 + sb18] = rawout[12] + prvblk[ch][sb18 + 12];
                prvblk[ch][sb18 + 12] = rawout[30];
                tsOut[13 + sb18] = rawout[13] + prvblk[ch][sb18 + 13];
                prvblk[ch][sb18 + 13] = rawout[31];
                tsOut[14 + sb18] = rawout[14] + prvblk[ch][sb18 + 14];
                prvblk[ch][sb18 + 14] = rawout[32];
                tsOut[15 + sb18] = rawout[15] + prvblk[ch][sb18 + 15];
                prvblk[ch][sb18 + 15] = rawout[33];
                tsOut[16 + sb18] = rawout[16] + prvblk[ch][sb18 + 16];
                prvblk[ch][sb18 + 16] = rawout[34];
                tsOut[17 + sb18] = rawout[17] + prvblk[ch][sb18 + 17];
                prvblk[ch][sb18 + 17] = rawout[35];
            }
        }

        private void do_downmix()
        {
            for (int sb = 0; sb < SSLIMIT; sb++)
            {
                for (int ss = 0; ss < SSLIMIT; ss += 3)
                {
                    lr[0][sb][ss] = (lr[0][sb][ss] + lr[1][sb][ss]) * 0.5f;
                    lr[0][sb][ss + 1] = (lr[0][sb][ss + 1] + lr[1][sb][ss + 1]) * 0.5f;
                    lr[0][sb][ss + 2] = (lr[0][sb][ss + 2] + lr[1][sb][ss + 2]) * 0.5f;
                }
            }
        }

        private void huffman_decode(int ch, int gr)
        {
            x[0] = 0;
            y[0] = 0;
            v[0] = 0;
            w[0] = 0;

            int part2_3_end = part2_start + si.ch[ch].gr[gr].part2_3_length;
            int num_bits;
            int region1Start;
            int region2Start;
            int index;

            int buf, buf1;

            HuffmanTable h;

            if (((si.ch[ch].gr[gr].window_switching_flag) != 0) && (si.ch[ch].gr[gr].block_type == 2))
            {

                region1Start = (sfreq == 8) ? 72 : 36;
                region2Start = 576;
            }
            else
            {
                buf = si.ch[ch].gr[gr].region0_count + 1;
                buf1 = buf + si.ch[ch].gr[gr].region1_count + 1;

                if (buf1 > sfBandIndex[sfreq].l.Length - 1)
                    buf1 = sfBandIndex[sfreq].l.Length - 1;

                region1Start = sfBandIndex[sfreq].l[buf];
                region2Start = sfBandIndex[sfreq].l[buf1];
            }

            index = 0;
            for (int i = 0; i < (si.ch[ch].gr[gr].big_values << 1); i += 2)
            {
                if (i < region1Start)
                    h = HuffmanTable.ht[si.ch[ch].gr[gr].table_select[0]];
                else if (i < region2Start)
                    h = HuffmanTable.ht[si.ch[ch].gr[gr].table_select[1]];
                else
                    h = HuffmanTable.ht[si.ch[ch].gr[gr].table_select[2]];

                HuffmanTable.huffman_decoder(h, x, y, v, w, br);

                is_1d[index++] = x[0];
                is_1d[index++] = y[0];
                CheckSumHuff = CheckSumHuff + x[0] + y[0];
                // System.out.println("x = "+x[0]+" y = "+y[0]);
            }

            h = HuffmanTable.ht[si.ch[ch].gr[gr].count1table_select + 32];
            num_bits = br.Hsstell();

            while ((num_bits < part2_3_end) && (index < 576))
            {

                HuffmanTable.huffman_decoder(h, x, y, v, w, br);

                is_1d[index++] = v[0];
                is_1d[index++] = w[0];
                is_1d[index++] = x[0];
                is_1d[index++] = y[0];
                CheckSumHuff = CheckSumHuff + v[0] + w[0] + x[0] + y[0];
                // System.out.println("v = "+v[0]+" w = "+w[0]);
                // System.out.println("x = "+x[0]+" y = "+y[0]);
                num_bits = br.Hsstell();
            }

            if (num_bits > part2_3_end)
            {
                br.RewindNbits(num_bits - part2_3_end);
                index -= 4;
            }

            num_bits = br.Hsstell();

            if (num_bits < part2_3_end)
                br.Hgetbits(part2_3_end - num_bits);

            if (index < 576)
                nonzero[ch] = index;
            else
                nonzero[ch] = 576;

            if (index < 0)
                index = 0;

            for (; index < 576; index++)
                is_1d[index] = 0;
        }

        private void i_stereo_k_values(int is_pos, int io_type, int i)
        {
            if (is_pos == 0)
            {
                k[0][i] = 1.0f;
                k[1][i] = 1.0f;
            }
            else if ((is_pos & 1) != 0)
            {
                k[0][i] = io[io_type][Util.URShift((is_pos + 1), 1)];
                k[1][i] = 1.0f;
            }
            else
            {
                k[0][i] = 1.0f;
                k[1][i] = io[io_type][Util.URShift(is_pos, 1)];
            }
        }

        private void dequantize_sample(float[][] xr, int ch, int gr)
        {
            gr_info_s gr_info = (si.ch[ch].gr[gr]);
            int cb = 0;
            int next_cb_boundary;
            int cb_begin = 0;
            int cb_width = 0;
            int index = 0, t_index, j;
            float g_gain;
            float[][] xr_1d = xr;
            if ((gr_info.window_switching_flag != 0) && (gr_info.block_type == 2))
            {
                if (gr_info.mixed_block_flag != 0)
                    next_cb_boundary = sfBandIndex[sfreq].l[1];
                else
                {
                    cb_width = sfBandIndex[sfreq].s[1];
                    next_cb_boundary = (cb_width << 2) - cb_width;
                    cb_begin = 0;
                }
            }
            else
            {
                next_cb_boundary = sfBandIndex[sfreq].l[1];
            }

            g_gain = (float)System.Math.Pow(2.0, (0.25 * (gr_info.global_gain - 210.0)));

            for (j = 0; j < nonzero[ch]; j++)
            {
                int reste = j % SSLIMIT;
                int quotien = (int)((j - reste) / SSLIMIT);
                if (is_1d[j] == 0)
                    xr_1d[quotien][reste] = 0.0f;
                else
                {
                    int abv = is_1d[j];
                    if (is_1d[j] > 0)
                        xr_1d[quotien][reste] = g_gain * t_43[abv];
                    else
                        xr_1d[quotien][reste] = -g_gain * t_43[-abv];
                }
            }
            for (j = 0; j < nonzero[ch]; j++)
            {
                int reste = j % SSLIMIT;
                int quotien = (int)((j - reste) / SSLIMIT);

                if (index == next_cb_boundary)
                {
                    if ((gr_info.window_switching_flag != 0) && (gr_info.block_type == 2))
                    {
                        if (gr_info.mixed_block_flag != 0)
                        {

                            if (index == sfBandIndex[sfreq].l[8])
                            {
                                next_cb_boundary = sfBandIndex[sfreq].s[4];
                                next_cb_boundary = (next_cb_boundary << 2) - next_cb_boundary;
                                cb = 3;
                                cb_width = sfBandIndex[sfreq].s[4] - sfBandIndex[sfreq].s[3];

                                cb_begin = sfBandIndex[sfreq].s[3];
                                cb_begin = (cb_begin << 2) - cb_begin;
                            }
                            else if (index < sfBandIndex[sfreq].l[8])
                            {

                                next_cb_boundary = sfBandIndex[sfreq].l[(++cb) + 1];
                            }
                            else
                            {

                                next_cb_boundary = sfBandIndex[sfreq].s[(++cb) + 1];
                                next_cb_boundary = (next_cb_boundary << 2) - next_cb_boundary;

                                cb_begin = sfBandIndex[sfreq].s[cb];
                                cb_width = sfBandIndex[sfreq].s[cb + 1] - cb_begin;
                                cb_begin = (cb_begin << 2) - cb_begin;
                            }
                        }
                        else
                        {

                            next_cb_boundary = sfBandIndex[sfreq].s[(++cb) + 1];
                            next_cb_boundary = (next_cb_boundary << 2) - next_cb_boundary;

                            cb_begin = sfBandIndex[sfreq].s[cb];
                            cb_width = sfBandIndex[sfreq].s[cb + 1] - cb_begin;
                            cb_begin = (cb_begin << 2) - cb_begin;
                        }
                    }
                    else
                    {
                        next_cb_boundary = sfBandIndex[sfreq].l[(++cb) + 1];
                    }
                }

                if ((gr_info.window_switching_flag != 0) && (((gr_info.block_type == 2) && (gr_info.mixed_block_flag == 0)) || ((gr_info.block_type == 2) && (gr_info.mixed_block_flag != 0) && (j >= 36))))
                {

                    t_index = (index - cb_begin) / cb_width;
                    /*            xr[sb][ss] *= pow(2.0, ((-2.0 * gr_info.subblock_gain[t_index])
                    -(0.5 * (1.0 + gr_info.scalefac_scale)
                    * scalefac[ch].s[t_index][cb]))); */
                    int idx = scalefac[ch].s[t_index][cb] << gr_info.scalefac_scale;
                    idx += (gr_info.subblock_gain[t_index] << 2);

                    xr_1d[quotien][reste] *= two_to_negative_half_pow[idx];
                }
                else
                {
                    // LONG block types 0,1,3 & 1st 2 subbands of switched blocks
                    /*				xr[sb][ss] *= pow(2.0, -0.5 * (1.0+gr_info.scalefac_scale)
                    * (scalefac[ch].l[cb]
                    + gr_info.preflag * pretab[cb])); */
                    int idx = scalefac[ch].l[cb];

                    if (gr_info.preflag != 0)
                        idx += pretab[cb];

                    idx = idx << gr_info.scalefac_scale;
                    xr_1d[quotien][reste] *= two_to_negative_half_pow[idx];
                }
                index++;
            }

            for (j = nonzero[ch]; j < 576; j++)
            {
                int reste = j % SSLIMIT;
                int quotien = (int)((j - reste) / SSLIMIT);
                if (reste < 0)
                    reste = 0;
                if (quotien < 0)
                    quotien = 0;
                xr_1d[quotien][reste] = 0.0f;
            }

            return;
        }

        private void reorder(float[][] xr, int ch, int gr)
        {
            gr_info_s gr_info = (si.ch[ch].gr[gr]);
            int freq, freq3;
            int index;
            int sfb, sfb_start, sfb_lines;
            int src_line, des_line;
            float[][] xr_1d = xr;

            if ((gr_info.window_switching_flag != 0) && (gr_info.block_type == 2))
            {

                for (index = 0; index < 576; index++)
                    out_1d[index] = 0.0f;

                if (gr_info.mixed_block_flag != 0)
                {
                    for (index = 0; index < 36; index++)
                    {
                        int reste = index % SSLIMIT;
                        int quotien = (int)((index - reste) / SSLIMIT);
                        out_1d[index] = xr_1d[quotien][reste];
                    }
                    for (sfb = 3, sfb_start = sfBandIndex[sfreq].s[3], sfb_lines = sfBandIndex[sfreq].s[4] - sfb_start; sfb < 13; sfb++, sfb_start = sfBandIndex[sfreq].s[sfb], sfb_lines = sfBandIndex[sfreq].s[sfb + 1] - sfb_start)
                    {
                        int sfb_start3 = (sfb_start << 2) - sfb_start;

                        for (freq = 0, freq3 = 0; freq < sfb_lines; freq++, freq3 += 3)
                        {

                            src_line = sfb_start3 + freq;
                            des_line = sfb_start3 + freq3;
                            int reste = src_line % SSLIMIT;
                            int quotien = (int)((src_line - reste) / SSLIMIT);

                            out_1d[des_line] = xr_1d[quotien][reste];
                            src_line += sfb_lines;
                            des_line++;

                            reste = src_line % SSLIMIT;
                            quotien = (int)((src_line - reste) / SSLIMIT);

                            out_1d[des_line] = xr_1d[quotien][reste];
                            src_line += sfb_lines;
                            des_line++;

                            reste = src_line % SSLIMIT;
                            quotien = (int)((src_line - reste) / SSLIMIT);

                            out_1d[des_line] = xr_1d[quotien][reste];
                        }
                    }
                }
                else
                {
                    for (index = 0; index < 576; index++)
                    {
                        int j = reorder_table[sfreq][index];
                        int reste = j % SSLIMIT;
                        int quotien = (int)((j - reste) / SSLIMIT);
                        out_1d[index] = xr_1d[quotien][reste];
                    }
                }
            }
            else
            {
                for (index = 0; index < 576; index++)
                {
                    int reste = index % SSLIMIT;
                    int quotien = (int)((index - reste) / SSLIMIT);
                    out_1d[index] = xr_1d[quotien][reste];
                }
            }
        }

        private void stereo(int gr)
        {
            int sb, ss;

            if (channels == 1)
            {
                for (sb = 0; sb < SBLIMIT; sb++)
                    for (ss = 0; ss < SSLIMIT; ss += 3)
                    {
                        lr[0][sb][ss] = ro[0][sb][ss];
                        lr[0][sb][ss + 1] = ro[0][sb][ss + 1];
                        lr[0][sb][ss + 2] = ro[0][sb][ss + 2];
                    }
            }
            else
            {
                gr_info_s gr_info = (si.ch[0].gr[gr]);
                int mode_ext = header.ModeExtension;
                int sfb;
                int i;
                int lines, temp, temp2;

                bool ms_stereo = ((header.Mode == Header.JOINT_STEREO) && ((mode_ext & 0x2) != 0));
                bool i_stereo = ((header.Mode == Header.JOINT_STEREO) && ((mode_ext & 0x1) != 0));
                bool lsf = ((header.Version == Header.MPEG2_LSF || header.Version == Header.MPEG25_LSF)); // SZD

                int io_type = (gr_info.scalefac_compress & 1);

                for (i = 0; i < 576; i++)
                {
                    is_pos[i] = 7;

                    is_ratio[i] = 0.0f;
                }

                if (i_stereo)
                {
                    if ((gr_info.window_switching_flag != 0) && (gr_info.block_type == 2))
                    {
                        if (gr_info.mixed_block_flag != 0)
                        {

                            int max_sfb = 0;

                            for (int j = 0; j < 3; j++)
                            {
                                int sfbcnt;
                                sfbcnt = 2;
                                for (sfb = 12; sfb >= 3; sfb--)
                                {
                                    i = sfBandIndex[sfreq].s[sfb];
                                    lines = sfBandIndex[sfreq].s[sfb + 1] - i;
                                    i = (i << 2) - i + (j + 1) * lines - 1;

                                    while (lines > 0)
                                    {
                                        if (ro[1][i / 18][i % 18] != 0.0f)
                                        {

                                            //if (ro[1][ss_div[i]][ss_mod[i]] != 0.0f) {
                                            sfbcnt = sfb;
                                            sfb = -10;
                                            lines = -10;
                                        }

                                        lines--;
                                        i--;
                                    }
                                }

                                sfb = sfbcnt + 1;

                                if (sfb > max_sfb)
                                    max_sfb = sfb;

                                while (sfb < 12)
                                {
                                    temp = sfBandIndex[sfreq].s[sfb];
                                    sb = sfBandIndex[sfreq].s[sfb + 1] - temp;
                                    i = (temp << 2) - temp + j * sb;

                                    for (; sb > 0; sb--)
                                    {
                                        is_pos[i] = scalefac[1].s[j][sfb];
                                        if (is_pos[i] != 7)
                                            if (lsf)
                                                i_stereo_k_values(is_pos[i], io_type, i);
                                            else
                                                is_ratio[i] = TAN12[is_pos[i]];

                                        i++;
                                    }

                                    sfb++;
                                }
                                sfb = sfBandIndex[sfreq].s[10];
                                sb = sfBandIndex[sfreq].s[11] - sfb;
                                sfb = (sfb << 2) - sfb + j * sb;
                                temp = sfBandIndex[sfreq].s[11];
                                sb = sfBandIndex[sfreq].s[12] - temp;
                                i = (temp << 2) - temp + j * sb;

                                for (; sb > 0; sb--)
                                {
                                    is_pos[i] = is_pos[sfb];

                                    if (lsf)
                                    {
                                        k[0][i] = k[0][sfb];
                                        k[1][i] = k[1][sfb];
                                    }
                                    else
                                    {
                                        is_ratio[i] = is_ratio[sfb];
                                    }
                                    i++;
                                }

                            }
                            if (max_sfb <= 3)
                            {
                                i = 2;
                                ss = 17;
                                sb = -1;
                                while (i >= 0)
                                {
                                    if (ro[1][i][ss] != 0.0f)
                                    {
                                        sb = (i << 4) + (i << 1) + ss;
                                        i = -1;
                                    }
                                    else
                                    {
                                        ss--;
                                        if (ss < 0)
                                        {
                                            i--;
                                            ss = 17;
                                        }
                                    }

                                }
                                i = 0;
                                while (sfBandIndex[sfreq].l[i] <= sb)
                                    i++;
                                sfb = i;
                                i = sfBandIndex[sfreq].l[i];
                                for (; sfb < 8; sfb++)
                                {
                                    sb = sfBandIndex[sfreq].l[sfb + 1] - sfBandIndex[sfreq].l[sfb];
                                    for (; sb > 0; sb--)
                                    {
                                        is_pos[i] = scalefac[1].l[sfb];
                                        if (is_pos[i] != 7)
                                            if (lsf)
                                                i_stereo_k_values(is_pos[i], io_type, i);
                                            else
                                                is_ratio[i] = TAN12[is_pos[i]];
                                        i++;
                                    }

                                }

                            }

                        }
                        else
                        {
                            // if (gr_info.mixed_block_flag)
                            for (int j = 0; j < 3; j++)
                            {
                                int sfbcnt;
                                sfbcnt = -1;
                                for (sfb = 12; sfb >= 0; sfb--)
                                {
                                    temp = sfBandIndex[sfreq].s[sfb];
                                    lines = sfBandIndex[sfreq].s[sfb + 1] - temp;
                                    i = (temp << 2) - temp + (j + 1) * lines - 1;

                                    while (lines > 0)
                                    {
                                        if (ro[1][i / 18][i % 18] != 0.0f)
                                        {

                                            //if (ro[1][ss_div[i]][ss_mod[i]] != 0.0f) {
                                            sfbcnt = sfb;
                                            sfb = -10;
                                            lines = -10;
                                        }
                                        lines--;
                                        i--;
                                    }
                                }

                                sfb = sfbcnt + 1;
                                while (sfb < 12)
                                {
                                    temp = sfBandIndex[sfreq].s[sfb];
                                    sb = sfBandIndex[sfreq].s[sfb + 1] - temp;
                                    i = (temp << 2) - temp + j * sb;
                                    for (; sb > 0; sb--)
                                    {
                                        is_pos[i] = scalefac[1].s[j][sfb];
                                        if (is_pos[i] != 7)
                                            if (lsf)
                                                i_stereo_k_values(is_pos[i], io_type, i);
                                            else
                                                is_ratio[i] = TAN12[is_pos[i]];
                                        i++;
                                    }

                                    sfb++;
                                }

                                temp = sfBandIndex[sfreq].s[10];
                                temp2 = sfBandIndex[sfreq].s[11];
                                sb = temp2 - temp;
                                sfb = (temp << 2) - temp + j * sb;
                                sb = sfBandIndex[sfreq].s[12] - temp2;
                                i = (temp2 << 2) - temp2 + j * sb;

                                for (; sb > 0; sb--)
                                {
                                    is_pos[i] = is_pos[sfb];

                                    if (lsf)
                                    {
                                        k[0][i] = k[0][sfb];
                                        k[1][i] = k[1][sfb];
                                    }
                                    else
                                    {
                                        is_ratio[i] = is_ratio[sfb];
                                    }
                                    i++;
                                }

                            }

                        }

                    }
                    else
                    {

                        i = 31;
                        ss = 17;
                        sb = 0;
                        while (i >= 0)
                        {
                            if (ro[1][i][ss] != 0.0f)
                            {
                                sb = (i << 4) + (i << 1) + ss;
                                i = -1;
                            }
                            else
                            {
                                ss--;
                                if (ss < 0)
                                {
                                    i--;
                                    ss = 17;
                                }
                            }
                        }
                        i = 0;
                        while (sfBandIndex[sfreq].l[i] <= sb)
                            i++;

                        sfb = i;
                        i = sfBandIndex[sfreq].l[i];
                        for (; sfb < 21; sfb++)
                        {
                            sb = sfBandIndex[sfreq].l[sfb + 1] - sfBandIndex[sfreq].l[sfb];
                            for (; sb > 0; sb--)
                            {
                                is_pos[i] = scalefac[1].l[sfb];
                                if (is_pos[i] != 7)
                                    if (lsf)
                                        i_stereo_k_values(is_pos[i], io_type, i);
                                    else
                                        is_ratio[i] = TAN12[is_pos[i]];
                                i++;
                            }
                        }
                        sfb = sfBandIndex[sfreq].l[20];
                        for (sb = 576 - sfBandIndex[sfreq].l[21]; (sb > 0) && (i < 576); sb--)
                        {
                            is_pos[i] = is_pos[sfb];
                            if (lsf)
                            {
                                k[0][i] = k[0][sfb];
                                k[1][i] = k[1][sfb];
                            }
                            else
                            {
                                is_ratio[i] = is_ratio[sfb];
                            }
                            i++;
                        }

                    }

                }


                i = 0;
                for (sb = 0; sb < SBLIMIT; sb++)
                    for (ss = 0; ss < SSLIMIT; ss++)
                    {
                        if (is_pos[i] == 7)
                        {
                            if (ms_stereo)
                            {
                                lr[0][sb][ss] = (ro[0][sb][ss] + ro[1][sb][ss]) * 0.707106781f;
                                lr[1][sb][ss] = (ro[0][sb][ss] - ro[1][sb][ss]) * 0.707106781f;
                            }
                            else
                            {
                                lr[0][sb][ss] = ro[0][sb][ss];
                                lr[1][sb][ss] = ro[1][sb][ss];
                            }
                        }
                        else if (i_stereo)
                        {

                            if (lsf)
                            {
                                lr[0][sb][ss] = ro[0][sb][ss] * k[0][i];
                                lr[1][sb][ss] = ro[0][sb][ss] * k[1][i];
                            }
                            else
                            {
                                lr[1][sb][ss] = ro[0][sb][ss] / (float)(1 + is_ratio[i]);
                                lr[0][sb][ss] = lr[1][sb][ss] * is_ratio[i];
                            }
                        }
                        /*				else {
                        System.out.println("Error in stereo processing\n");
                        } */
                        i++;
                    }
            }

        }

        private void antialias(int ch, int gr)
        {
            int sb18, ss, sb18lim;
            gr_info_s gr_info = (si.ch[ch].gr[gr]);

            if ((gr_info.window_switching_flag != 0) && (gr_info.block_type == 2) && !(gr_info.mixed_block_flag != 0))
                return;

            if ((gr_info.window_switching_flag != 0) && (gr_info.mixed_block_flag != 0) && (gr_info.block_type == 2))
            {
                sb18lim = 18;
            }
            else
            {
                sb18lim = 558;
            }

            for (sb18 = 0; sb18 < sb18lim; sb18 += 18)
            {
                for (ss = 0; ss < 8; ss++)
                {
                    int src_idx1 = sb18 + 17 - ss;
                    int src_idx2 = sb18 + 18 + ss;
                    float bu = out_1d[src_idx1];
                    float bd = out_1d[src_idx2];
                    out_1d[src_idx1] = (bu * cs[ss]) - (bd * ca[ss]);
                    out_1d[src_idx2] = (bd * cs[ss]) + (bu * ca[ss]);
                }
            }
        }
        #endregion

        #region Internal methods
        internal static int[] reorder(int[] scalefac_band)
        {
            int j = 0;
            int[] ix = new int[576];
            for (int sfb = 0; sfb < 13; sfb++)
            {
                int start = scalefac_band[sfb];
                int end = scalefac_band[sfb + 1];
                for (int window = 0; window < 3; window++)
                    for (int i = start; i < end; i++)
                        ix[3 * i + window] = j++;
            }
            return ix;
        }

        internal virtual OBuffer DecodeFrame(Header header, BitStream stream)
        {
            if (!this.initialized)
            {
                this.Initialize();
            }

            this.buffer.clear_buffer();

            this.decodeFrame();

            this.buffer.write_buffer(1);

            return this.buffer;
        }
        #endregion

        #region Public methods
        public void seek_notify()
        {
            frame_start = 0;
            for (int ch = 0; ch < 2; ch++)
                for (int j = 0; j < 576; j++)
                    prevblck[ch][j] = 0.0f;
            br = new BitReserve();
        }

        public void decodeFrame()
        {
            //float start = (float)
            System.Threading.Thread.Sleep(23);
            decode();
        }

        public void decode()
        {
            int nSlots = header.Slots;
            int flush_main;
            int gr, ch, ss, sb, sb18;
            int main_data_end;
            int bytes_to_discard;
            int i;

            get_side_info();

            for (i = 0; i < nSlots; i++)
                br.Hputbuf(stream.GetBits(8));

            main_data_end = Util.URShift(br.Hsstell(), 3); // of previous frame

            if ((flush_main = (br.Hsstell() & 7)) != 0)
            {
                br.Hgetbits(8 - flush_main);
                main_data_end++;
            }

            bytes_to_discard = frame_start - main_data_end - si.main_data_begin;

            frame_start += nSlots;

            if (bytes_to_discard < 0)
                return;

            if (main_data_end > 4096)
            {
                frame_start -= 4096;
                br.RewindNbytes(4096);
            }

            for (; bytes_to_discard > 0; bytes_to_discard--)
                br.Hgetbits(8);

            for (gr = 0; gr < max_gr; gr++)
            {

                for (ch = 0; ch < channels; ch++)
                {
                    part2_start = br.Hsstell();

                    if (header.Version == Header.MPEG1)
                        get_scale_factors(ch, gr);
                    else
                        get_LSF_scale_factors(ch, gr);

                    huffman_decode(ch, gr);
                    // System.out.println("CheckSum HuffMan = " + CheckSumHuff);
                    dequantize_sample(ro[ch], ch, gr);
                }

                // copia do array
                for (i = 0; i < 288; i++)
                {
                    int j = i / 18;
                    int k = i % 18;

                    //ro_copy[i] = 96.0f + (float) (100 * 10 * System.Math.Log10(ro[0][j][k] * ro[0][j][k]));//System.Math.Abs(ro[0][j][k]);// +ro[1][j][k];
                    ro_copy[i] = Math.Abs(ro[0][j][k]);
                }
                this.beatDetector.ReadFrequencies(ro[0]);
                //

                stereo(gr);

                if ((which_channels == (int)OutputChannelsEnum.DOWNMIX_CHANNELS) && (channels > 1))
                    do_downmix();

                for (ch = first_channel; ch <= last_channel; ch++)
                {

                    reorder(lr[ch], ch, gr);
                    antialias(ch, gr);
                    //for (int hb = 0;hb<576;hb++) CheckSumOut1d = CheckSumOut1d + out_1d[hb];
                    //System.out.println("CheckSumOut1d = "+CheckSumOut1d);

                    hybrid(ch, gr);

                    //for (int hb = 0;hb<576;hb++) CheckSumOut1d = CheckSumOut1d + out_1d[hb];
                    //System.out.println("CheckSumOut1d = "+CheckSumOut1d);

                    for (sb18 = 18; sb18 < 576; sb18 += 36)
                        for (ss = 1; ss < SSLIMIT; ss += 2)
                            out_1d[sb18 + ss] = -out_1d[sb18 + ss];

                    if ((ch == 0) || (which_channels == (int)OutputChannelsEnum.RIGHT_CHANNEL))
                    {
                        for (ss = 0; ss < SSLIMIT; ss++)
                        {
                            sb = 0;
                            for (sb18 = 0; sb18 < 576; sb18 += 18)
                            {
                                samples1[sb] = out_1d[sb18 + ss];
                                sb++;
                            }
                            //buffer.appendSamples(0, samples1);
                            //Console.WriteLine("Adding samples right into output buffer");
                            filter1.input_samples(samples1);
                            filter1.calculate_pcm_samples(buffer);
                        }
                    }
                    else
                    {
                        for (ss = 0; ss < SSLIMIT; ss++)
                        {
                            sb = 0;
                            for (sb18 = 0; sb18 < 576; sb18 += 18)
                            {
                                samples2[sb] = out_1d[sb18 + ss];
                                sb++;
                            }
                            //buffer.appendSamples(1, samples2);
                            //Console.WriteLine("Adding samples right into output buffer");
                            filter2.input_samples(samples2);
                            filter2.calculate_pcm_samples(buffer);
                        }
                    }
                }
            }
            // System.out.println("Counter = ................................."+counter);
            //if (counter <  609)
            //{
            counter++;
            buffer.write_buffer(1);
            //}
            //else if (counter == 609)
            //{
            //    buffer.close();
            //    counter++;
            //}
            //else
            //{
            //}
        }

        public void inv_mdct(float[] in_Renamed, float[] out_Renamed, int block_type)
        {
            float[] win_bt;
            int i;

            float tmpf_0, tmpf_1, tmpf_2, tmpf_3, tmpf_4, tmpf_5, tmpf_6, tmpf_7, tmpf_8, tmpf_9;
            float tmpf_10, tmpf_11, tmpf_12, tmpf_13, tmpf_14, tmpf_15, tmpf_16, tmpf_17;

            tmpf_0 = tmpf_1 = tmpf_2 = tmpf_3 = tmpf_4 = tmpf_5 = tmpf_6 = tmpf_7 = tmpf_8 = tmpf_9 = tmpf_10 = tmpf_11 = tmpf_12 = tmpf_13 = tmpf_14 = tmpf_15 = tmpf_16 = tmpf_17 = 0.0f;



            if (block_type == 2)
            {

                /*
                for(int p=0;p<36;p+=9)
                {
                out[p]   = out[p+1] = out[p+2] = out[p+3] =
                out[p+4] = out[p+5] = out[p+6] = out[p+7] =
                out[p+8] = 0.0f;
                }
                */
                out_Renamed[0] = 0.0f;
                out_Renamed[1] = 0.0f;
                out_Renamed[2] = 0.0f;
                out_Renamed[3] = 0.0f;
                out_Renamed[4] = 0.0f;
                out_Renamed[5] = 0.0f;
                out_Renamed[6] = 0.0f;
                out_Renamed[7] = 0.0f;
                out_Renamed[8] = 0.0f;
                out_Renamed[9] = 0.0f;
                out_Renamed[10] = 0.0f;
                out_Renamed[11] = 0.0f;
                out_Renamed[12] = 0.0f;
                out_Renamed[13] = 0.0f;
                out_Renamed[14] = 0.0f;
                out_Renamed[15] = 0.0f;
                out_Renamed[16] = 0.0f;
                out_Renamed[17] = 0.0f;
                out_Renamed[18] = 0.0f;
                out_Renamed[19] = 0.0f;
                out_Renamed[20] = 0.0f;
                out_Renamed[21] = 0.0f;
                out_Renamed[22] = 0.0f;
                out_Renamed[23] = 0.0f;
                out_Renamed[24] = 0.0f;
                out_Renamed[25] = 0.0f;
                out_Renamed[26] = 0.0f;
                out_Renamed[27] = 0.0f;
                out_Renamed[28] = 0.0f;
                out_Renamed[29] = 0.0f;
                out_Renamed[30] = 0.0f;
                out_Renamed[31] = 0.0f;
                out_Renamed[32] = 0.0f;
                out_Renamed[33] = 0.0f;
                out_Renamed[34] = 0.0f;
                out_Renamed[35] = 0.0f;

                int six_i = 0;

                for (i = 0; i < 3; i++)
                {
                    in_Renamed[15 + i] += in_Renamed[12 + i]; in_Renamed[12 + i] += in_Renamed[9 + i]; in_Renamed[9 + i] += in_Renamed[6 + i];
                    in_Renamed[6 + i] += in_Renamed[3 + i]; in_Renamed[3 + i] += in_Renamed[0 + i];

                    in_Renamed[15 + i] += in_Renamed[9 + i]; in_Renamed[9 + i] += in_Renamed[3 + i];

                    float pp1, pp2, sum;
                    pp2 = in_Renamed[12 + i] * 0.500000000f;
                    pp1 = in_Renamed[6 + i] * 0.866025403f;
                    sum = in_Renamed[0 + i] + pp2;
                    tmpf_1 = in_Renamed[0 + i] - in_Renamed[12 + i];
                    tmpf_0 = sum + pp1;
                    tmpf_2 = sum - pp1;

                    pp2 = in_Renamed[15 + i] * 0.500000000f;
                    pp1 = in_Renamed[9 + i] * 0.866025403f;
                    sum = in_Renamed[3 + i] + pp2;
                    tmpf_4 = in_Renamed[3 + i] - in_Renamed[15 + i];
                    tmpf_5 = sum + pp1;
                    tmpf_3 = sum - pp1;

                    tmpf_3 *= 1.931851653f;
                    tmpf_4 *= 0.707106781f;
                    tmpf_5 *= 0.517638090f;

                    float save = tmpf_0;
                    tmpf_0 += tmpf_5;
                    tmpf_5 = save - tmpf_5;
                    save = tmpf_1;
                    tmpf_1 += tmpf_4;
                    tmpf_4 = save - tmpf_4;
                    save = tmpf_2;
                    tmpf_2 += tmpf_3;
                    tmpf_3 = save - tmpf_3;


                    tmpf_0 *= 0.504314480f;
                    tmpf_1 *= 0.541196100f;
                    tmpf_2 *= 0.630236207f;
                    tmpf_3 *= 0.821339815f;
                    tmpf_4 *= 1.306562965f;
                    tmpf_5 *= 3.830648788f;

                    tmpf_8 = -tmpf_0 * 0.793353340f;
                    tmpf_9 = -tmpf_0 * 0.608761429f;
                    tmpf_7 = -tmpf_1 * 0.923879532f;
                    tmpf_10 = -tmpf_1 * 0.382683432f;
                    tmpf_6 = -tmpf_2 * 0.991444861f;
                    tmpf_11 = -tmpf_2 * 0.130526192f;

                    tmpf_0 = tmpf_3;
                    tmpf_1 = tmpf_4 * 0.382683432f;
                    tmpf_2 = tmpf_5 * 0.608761429f;

                    tmpf_3 = -tmpf_5 * 0.793353340f;
                    tmpf_4 = -tmpf_4 * 0.923879532f;
                    tmpf_5 = -tmpf_0 * 0.991444861f;

                    tmpf_0 *= 0.130526192f;

                    out_Renamed[six_i + 6] += tmpf_0;
                    out_Renamed[six_i + 7] += tmpf_1;
                    out_Renamed[six_i + 8] += tmpf_2;
                    out_Renamed[six_i + 9] += tmpf_3;
                    out_Renamed[six_i + 10] += tmpf_4;
                    out_Renamed[six_i + 11] += tmpf_5;
                    out_Renamed[six_i + 12] += tmpf_6;
                    out_Renamed[six_i + 13] += tmpf_7;
                    out_Renamed[six_i + 14] += tmpf_8;
                    out_Renamed[six_i + 15] += tmpf_9;
                    out_Renamed[six_i + 16] += tmpf_10;
                    out_Renamed[six_i + 17] += tmpf_11;

                    six_i += 6;
                }
            }
            else
            {
                in_Renamed[17] += in_Renamed[16]; in_Renamed[16] += in_Renamed[15]; in_Renamed[15] += in_Renamed[14]; in_Renamed[14] += in_Renamed[13];
                in_Renamed[13] += in_Renamed[12]; in_Renamed[12] += in_Renamed[11]; in_Renamed[11] += in_Renamed[10]; in_Renamed[10] += in_Renamed[9];
                in_Renamed[9] += in_Renamed[8]; in_Renamed[8] += in_Renamed[7]; in_Renamed[7] += in_Renamed[6]; in_Renamed[6] += in_Renamed[5];
                in_Renamed[5] += in_Renamed[4]; in_Renamed[4] += in_Renamed[3]; in_Renamed[3] += in_Renamed[2]; in_Renamed[2] += in_Renamed[1];
                in_Renamed[1] += in_Renamed[0];

                in_Renamed[17] += in_Renamed[15]; in_Renamed[15] += in_Renamed[13]; in_Renamed[13] += in_Renamed[11]; in_Renamed[11] += in_Renamed[9];
                in_Renamed[9] += in_Renamed[7]; in_Renamed[7] += in_Renamed[5]; in_Renamed[5] += in_Renamed[3]; in_Renamed[3] += in_Renamed[1];

                float tmp0, tmp1, tmp2, tmp3, tmp4, tmp0_, tmp1_, tmp2_, tmp3_;
                float tmp0o, tmp1o, tmp2o, tmp3o, tmp4o, tmp0_o, tmp1_o, tmp2_o, tmp3_o;

                float i00 = in_Renamed[0] + in_Renamed[0];
                float iip12 = i00 + in_Renamed[12];

                tmp0 = iip12 + in_Renamed[4] * 1.8793852415718f + in_Renamed[8] * 1.532088886238f + in_Renamed[16] * 0.34729635533386f;
                tmp1 = i00 + in_Renamed[4] - in_Renamed[8] - in_Renamed[12] - in_Renamed[12] - in_Renamed[16];
                tmp2 = iip12 - in_Renamed[4] * 0.34729635533386f - in_Renamed[8] * 1.8793852415718f + in_Renamed[16] * 1.532088886238f;
                tmp3 = iip12 - in_Renamed[4] * 1.532088886238f + in_Renamed[8] * 0.34729635533386f - in_Renamed[16] * 1.8793852415718f;
                tmp4 = in_Renamed[0] - in_Renamed[4] + in_Renamed[8] - in_Renamed[12] + in_Renamed[16];

                float i66_ = in_Renamed[6] * 1.732050808f;

                tmp0_ = in_Renamed[2] * 1.9696155060244f + i66_ + in_Renamed[10] * 1.2855752193731f + in_Renamed[14] * 0.68404028665134f;
                tmp1_ = (in_Renamed[2] - in_Renamed[10] - in_Renamed[14]) * 1.732050808f;
                tmp2_ = in_Renamed[2] * 1.2855752193731f - i66_ - in_Renamed[10] * 0.68404028665134f + in_Renamed[14] * 1.9696155060244f;
                tmp3_ = in_Renamed[2] * 0.68404028665134f - i66_ + in_Renamed[10] * 1.9696155060244f - in_Renamed[14] * 1.2855752193731f;

                float i0 = in_Renamed[0 + 1] + in_Renamed[0 + 1];
                float i0p12 = i0 + in_Renamed[12 + 1];

                tmp0o = i0p12 + in_Renamed[4 + 1] * 1.8793852415718f + in_Renamed[8 + 1] * 1.532088886238f + in_Renamed[16 + 1] * 0.34729635533386f;
                tmp1o = i0 + in_Renamed[4 + 1] - in_Renamed[8 + 1] - in_Renamed[12 + 1] - in_Renamed[12 + 1] - in_Renamed[16 + 1];
                tmp2o = i0p12 - in_Renamed[4 + 1] * 0.34729635533386f - in_Renamed[8 + 1] * 1.8793852415718f + in_Renamed[16 + 1] * 1.532088886238f;
                tmp3o = i0p12 - in_Renamed[4 + 1] * 1.532088886238f + in_Renamed[8 + 1] * 0.34729635533386f - in_Renamed[16 + 1] * 1.8793852415718f;
                tmp4o = (in_Renamed[0 + 1] - in_Renamed[4 + 1] + in_Renamed[8 + 1] - in_Renamed[12 + 1] + in_Renamed[16 + 1]) * 0.707106781f; // Twiddled

                float i6_ = in_Renamed[6 + 1] * 1.732050808f;

                tmp0_o = in_Renamed[2 + 1] * 1.9696155060244f + i6_ + in_Renamed[10 + 1] * 1.2855752193731f + in_Renamed[14 + 1] * 0.68404028665134f;
                tmp1_o = (in_Renamed[2 + 1] - in_Renamed[10 + 1] - in_Renamed[14 + 1]) * 1.732050808f;
                tmp2_o = in_Renamed[2 + 1] * 1.2855752193731f - i6_ - in_Renamed[10 + 1] * 0.68404028665134f + in_Renamed[14 + 1] * 1.9696155060244f;
                tmp3_o = in_Renamed[2 + 1] * 0.68404028665134f - i6_ + in_Renamed[10 + 1] * 1.9696155060244f - in_Renamed[14 + 1] * 1.2855752193731f;

                float e, o;
                e = tmp0 + tmp0_; o = (tmp0o + tmp0_o) * 0.501909918f; tmpf_0 = e + o; tmpf_17 = e - o;
                e = tmp1 + tmp1_; o = (tmp1o + tmp1_o) * 0.517638090f; tmpf_1 = e + o; tmpf_16 = e - o;
                e = tmp2 + tmp2_; o = (tmp2o + tmp2_o) * 0.551688959f; tmpf_2 = e + o; tmpf_15 = e - o;
                e = tmp3 + tmp3_; o = (tmp3o + tmp3_o) * 0.610387294f; tmpf_3 = e + o; tmpf_14 = e - o;
                tmpf_4 = tmp4 + tmp4o; tmpf_13 = tmp4 - tmp4o;
                e = tmp3 - tmp3_; o = (tmp3o - tmp3_o) * 0.871723397f; tmpf_5 = e + o; tmpf_12 = e - o;
                e = tmp2 - tmp2_; o = (tmp2o - tmp2_o) * 1.183100792f; tmpf_6 = e + o; tmpf_11 = e - o;
                e = tmp1 - tmp1_; o = (tmp1o - tmp1_o) * 1.931851653f; tmpf_7 = e + o; tmpf_10 = e - o;
                e = tmp0 - tmp0_; o = (tmp0o - tmp0_o) * 5.736856623f; tmpf_8 = e + o; tmpf_9 = e - o;

                win_bt = win[block_type];

                out_Renamed[0] = -tmpf_9 * win_bt[0];
                out_Renamed[1] = -tmpf_10 * win_bt[1];
                out_Renamed[2] = -tmpf_11 * win_bt[2];
                out_Renamed[3] = -tmpf_12 * win_bt[3];
                out_Renamed[4] = -tmpf_13 * win_bt[4];
                out_Renamed[5] = -tmpf_14 * win_bt[5];
                out_Renamed[6] = -tmpf_15 * win_bt[6];
                out_Renamed[7] = -tmpf_16 * win_bt[7];
                out_Renamed[8] = -tmpf_17 * win_bt[8];
                out_Renamed[9] = tmpf_17 * win_bt[9];
                out_Renamed[10] = tmpf_16 * win_bt[10];
                out_Renamed[11] = tmpf_15 * win_bt[11];
                out_Renamed[12] = tmpf_14 * win_bt[12];
                out_Renamed[13] = tmpf_13 * win_bt[13];
                out_Renamed[14] = tmpf_12 * win_bt[14];
                out_Renamed[15] = tmpf_11 * win_bt[15];
                out_Renamed[16] = tmpf_10 * win_bt[16];
                out_Renamed[17] = tmpf_9 * win_bt[17];
                out_Renamed[18] = tmpf_8 * win_bt[18];
                out_Renamed[19] = tmpf_7 * win_bt[19];
                out_Renamed[20] = tmpf_6 * win_bt[20];
                out_Renamed[21] = tmpf_5 * win_bt[21];
                out_Renamed[22] = tmpf_4 * win_bt[22];
                out_Renamed[23] = tmpf_3 * win_bt[23];
                out_Renamed[24] = tmpf_2 * win_bt[24];
                out_Renamed[25] = tmpf_1 * win_bt[25];
                out_Renamed[26] = tmpf_0 * win_bt[26];
                out_Renamed[27] = tmpf_0 * win_bt[27];
                out_Renamed[28] = tmpf_1 * win_bt[28];
                out_Renamed[29] = tmpf_2 * win_bt[29];
                out_Renamed[30] = tmpf_3 * win_bt[30];
                out_Renamed[31] = tmpf_4 * win_bt[31];
                out_Renamed[32] = tmpf_5 * win_bt[32];
                out_Renamed[33] = tmpf_6 * win_bt[33];
                out_Renamed[34] = tmpf_7 * win_bt[34];
                out_Renamed[35] = tmpf_8 * win_bt[35];
            }
        }
        #endregion

        #region Internal classes
        internal class SBI
        {
            public int[] l;
            public int[] s;

            #region Constructors
            public SBI()
            {
                l = new int[23];
                s = new int[14];
            }
            public SBI(int[] thel, int[] thes)
            {
                l = thel;
                s = thes;
            }
            #endregion
        }

        internal class gr_info_s
        {
            public int part2_3_length = 0;
            public int big_values = 0;
            public int global_gain = 0;
            public int scalefac_compress = 0;
            public int window_switching_flag = 0;
            public int block_type = 0;
            public int mixed_block_flag = 0;
            public int[] table_select;
            public int[] subblock_gain;
            public int region0_count = 0;
            public int region1_count = 0;
            public int preflag = 0;
            public int scalefac_scale = 0;
            public int count1table_select = 0;

            #region Constructors
            public gr_info_s()
            {
                table_select = new int[3];
                subblock_gain = new int[3];
            }
            #endregion
        }

        internal class temporaire
        {
            public int[] scfsi;
            public gr_info_s[] gr;

            #region Contructors
            public temporaire()
            {
                scfsi = new int[4];
                gr = new gr_info_s[2];
                gr[0] = new gr_info_s();
                gr[1] = new gr_info_s();
            }
            #endregion
        }

        internal class III_side_info_t
        {

            public int main_data_begin = 0;
            public int private_bits = 0;
            public temporaire[] ch;

            #region Constructors
            public III_side_info_t()
            {
                ch = new temporaire[2];
                ch[0] = new temporaire();
                ch[1] = new temporaire();
            }
            #endregion
        }

        internal class temporaire2
        {
            public int[] l;
            public int[][] s;

            #region Constructor
            public temporaire2()
            {
                l = new int[23];
                s = new int[3][];
                for (int i = 0; i < 3; i++)
                {
                    s[i] = new int[13];
                }
            }
            #endregion
        }

        internal class Sftable
        {
            private void InitBlock(MP3Decoder enclosingInstance)
            {
                this.enclosingInstance = enclosingInstance;
            }
            private MP3Decoder enclosingInstance;

            #region Properties
            public MP3Decoder Enclosing_Instance
            {
                get
                {
                    return enclosingInstance;
                }

            }
            #endregion

            public int[] l;
            public int[] s;

            #region Constructors
            public Sftable(MP3Decoder enclosingInstance)
            {
                InitBlock(enclosingInstance);
                l = new int[5];
                s = new int[3];
            }

            public Sftable(MP3Decoder enclosingInstance, int[] thel, int[] thes)
            {
                InitBlock(enclosingInstance);
                l = thel;
                s = thes;
            }
            #endregion
        }

        internal class Equalizer
        {
            public static readonly float BAND_NOT_PRESENT = System.Single.NegativeInfinity;
            private const int BANDS = 32;
            private float[] settings;

            #region Constructors
            public Equalizer()
            {
                InitBlock();
            }
            #endregion

            #region Properties
            internal virtual float[] BandFactors
            {
                get
                {
                    float[] factors = new float[BANDS];
                    for (int i = 0, maxCount = BANDS; i < maxCount; i++)
                    {
                        factors[i] = getBandFactor(settings[i]);
                    }

                    return factors;
                }
            }
            #endregion

            #region Private Methods
            private void InitBlock()
            {
                settings = new float[BANDS];
            }
            #endregion

            #region Internal Methods
            internal float getBandFactor(float eq)
            {
                if (eq == BAND_NOT_PRESENT)
                {
                    return 0.0f;
                }

                float f = (float)System.Math.Pow(2.0, eq);
                return f;
            }
            #endregion
        }

        internal class HuffmanTable
        {
            private const int MXOFF = 250;
            private const int HTN = 34;

            private char tablename0 = ' '; /* string, containing table_description   */
            private char tablename1 = ' '; /* string, containing table_description   */
            private char tablename2 = ' '; /* string, containing table_description   */

            private int xlen; /* max. x-index+ */
            private int ylen; /* max. y-index+ */
            private int linbits; /* number of linbits */
            private int linmax; /* max number to be stored in linbits */
            private int ref_Renamed; /* a positive value indicates a reference */
            private int[] table = null; /* pointer to array[xlen][ylen] */
            private int[] hlen = null; /* pointer to array[xlen][ylen] */
            private int[][] val = null; /* decoder tree	*/
            private int treelen; /* length of decoder tree */

            private static int[][] ValTab0 = { new int[] { 0, 0 } };

            private static int[][] ValTab1 = { new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 2, 1 }, new int[] { 0, 16 }, new int[] { 2, 1 }, new int[] { 0, 1 }, new int[] { 0, 17 } };

            private static int[][] ValTab2 = { new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 16 }, new int[] { 0, 1 }, new int[] { 2, 1 }, new int[] { 0, 17 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 32 }, new int[] { 0, 33 }, new int[] { 2, 1 }, new int[] { 0, 18 }, new int[] { 2, 1 }, new int[] { 0, 2 }, new int[] { 0, 34 } };

            private static int[][] ValTab3 = { new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 0, 1 }, new int[] { 2, 1 }, new int[] { 0, 17 }, new int[] { 2, 1 }, new int[] { 0, 16 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 32 }, new int[] { 0, 33 }, new int[] { 2, 1 }, new int[] { 0, 18 }, new int[] { 2, 1 }, new int[] { 0, 2 }, new int[] { 0, 34 } };

            private static int[][] ValTab4 = { new int[] { 0, 0 } };

            private static int[][] ValTab5 = { new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 16 }, new int[] { 0, 1 }, new int[] { 2, 1 }, new int[] { 0, 17 }, new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 32 }, new int[] { 0, 2 }, new int[] { 2, 1 }, new int[] { 0, 33 }, new int[] { 0, 18 }, new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 34 }, new int[] { 0, 48 }, new int[] { 2, 1 }, new int[] { 0, 3 }, new int[] { 0, 19 }, new int[] { 2, 1 }, new int[] { 0, 49 }, new int[] { 2, 1 }, new int[] { 0, 50 }, new int[] { 2, 1 }, new int[] { 0, 35 }, new int[] { 0, 51 } };

            private static int[][] ValTab6 = { new int[] { 6, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 0, 16 }, new int[] { 0, 17 }, new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 1 }, new int[] { 2, 1 }, new int[] { 0, 32 }, new int[] { 0, 33 }, new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 18 }, new int[] { 2, 1 }, new int[] { 0, 2 }, new int[] { 0, 34 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 49 }, new int[] { 0, 19 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 48 }, new int[] { 0, 50 }, new int[] { 2, 1 }, new int[] { 0, 35 }, new int[] { 2, 1 }, new int[] { 0, 3 }, new int[] { 0, 51 } };

            private static int[][] ValTab7 = { new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 16 }, new int[] { 0, 1 }, new int[] { 8, 1 }, new int[] { 2, 1 }, new int[] { 0, 17 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 32 }, new int[] { 0, 2 }, new int[] { 0, 33 }, new int[] { 18, 1 }, new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 18 }, new int[] { 2, 1 }, new int[] { 0, 34 }, new int[] { 0, 48 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 49 }, new int[] { 0, 19 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 3 }, new int[] { 0, 50 }, new int[] { 2, 1 }, new int[] { 0, 35 }, new int[] { 0, 4 }, new int[] { 10, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 64 }, new int[] { 0, 65 }, new int[] { 2, 1 }, new int[] { 0, 20 }, new int[] { 2, 1 }, new int[] { 0, 66 }, new int[] { 0, 36 }, new int[] { 12, 1 }, new int[] { 6, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 51 }, new int[] { 0, 67 }, new int[] { 0, 80 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 52 }, new int[] { 0, 5 }, new int[] { 0, 81 }, new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 21 }, new int[] { 2, 1 }, new int[] { 0, 82 }, new int[] { 0, 37 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 68 }, new int[] { 0, 53 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 83 }, new int[] { 0, 84 }, new int[] { 2, 1 }, new int[] { 0, 69 }, new int[] { 0, 85 } };

            private static int[][] ValTab8 = { new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 2, 1 }, new int[] { 0, 16 }, new int[] { 0, 1 }, new int[] { 2, 1 }, new int[] { 0, 17 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 33 }, new int[] { 0, 18 }, new int[] { 14, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 32 }, new int[] { 0, 2 }, new int[] { 2, 1 }, new int[] { 0, 34 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 48 }, new int[] { 0, 3 }, new int[] { 2, 1 }, new int[] { 0, 49 }, new int[] { 0, 19 }, new int[] { 14, 1 }, new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 50 }, new int[] { 0, 35 }, new int[] { 2, 1 }, new int[] { 0, 64 }, new int[] { 0, 4 }, new int[] { 2, 1 }, new int[] { 0, 65 }, new int[] { 2, 1 }, new int[] { 0, 20 }, new int[] { 0, 66 }, new int[] { 12, 1 }, new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 36 }, new int[] { 2, 1 }, new int[] { 0, 51 }, new int[] { 0, 80 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 67 }, new int[] { 0, 52 }, new int[] { 0, 81 }, new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 21 }, new int[] { 2, 1 }, new int[] { 0, 5 }, new int[] { 0, 82 }, new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 37 }, new int[] { 2, 1 }, new int[] { 0, 68 }, new int[] { 0, 53 }, new int[] { 2, 1 }, new int[] { 0, 83 }, new int[] { 2, 1 }, new int[] { 0, 69 }, new int[] { 2, 1 }, new int[] { 0, 84 }, new int[] { 0, 85 } };

            private static int[][] ValTab9 = { new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 0, 16 }, new int[] { 2, 1 }, new int[] { 0, 1 }, new int[] { 0, 17 }, new int[] { 10, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 32 }, new int[] { 0, 33 }, new int[] { 2, 1 }, new int[] { 0, 18 }, new int[] { 2, 1 }, new int[] { 0, 2 }, new int[] { 0, 34 }, new int[] { 12, 1 }, new int[] { 6, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 48 }, new int[] { 0, 3 }, new int[] { 0, 49 }, new int[] { 2, 1 }, new int[] { 0, 19 }, new int[] { 2, 1 }, new int[] { 0, 50 }, new int[] { 0, 35 }, new int[] { 12, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 65 }, new int[] { 0, 20 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 64 }, new int[] { 0, 51 }, new int[] { 2, 1 }, new int[] { 0, 66 }, new int[] { 0, 36 }, new int[] { 10, 1 }, new int[] { 6, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 4 }, new int[] { 0, 80 }, new int[] { 0, 67 }, new int[] { 2, 1 }, new int[] { 0, 52 }, new int[] { 0, 81 }, new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 21 }, new int[] { 0, 82 }, new int[] { 2, 1 }, new int[] { 0, 37 }, new int[] { 0, 68 }, new int[] { 6, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 5 }, new int[] { 0, 84 }, new int[] { 0, 83 }, new int[] { 2, 1 }, new int[] { 0, 53 }, new int[] { 2, 1 }, new int[] { 0, 69 }, new int[] { 0, 85 } };

            private static int[][] ValTab10 = {new int[]{2, 1}, new int[]{0, 0}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 16}, new int[]{0, 1}, new int[]{10, 1}, new int[]{2, 1}, new int[]{0, 17}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 32}, new int[]{0, 2}, new int[]{2, 1}, new int[]{0, 33}, new int[]{0, 18}, new int[]{28, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 34}, new int[]{0, 48}, new int[]{2, 1}, new int[]{0, 49}, new int[]{0, 19}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 3}, new int[]{0, 50}, new int[]{2, 1}, new int[]{0, 35}, new int[]{0, 64}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 65}, new int[]{0, 20}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 4}, new int[]{0, 51}, new int[]{2, 1}, new int[]{0, 66}, new int[]{0, 36}, new int[]{28, 1}, new int[]{10, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 80}, new int[]{0, 5}, new int[]{0, 96}, new int[]{2, 1}, new int[]{0, 97}, new int[]{0, 22}, new int[]{12, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 67}, new int[]{0, 52}, new int[]{0, 81}, new int[]{2, 1}, new int[]{0, 21}, new int[]{2, 1}, new int[]{0, 82}, new int[]{0, 37}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 38}, new int[]{0, 54}, new int[]{0, 113}, new int[]{20, 1}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 23}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 68}, new int[]{0, 83}, new int[]{0, 6}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 53}, new int[]{0, 69}, new int[]{0, 98}, new int[]{2, 1}, new int[]{0, 112}, new int[]{2, 1}, new int[]{0, 7}, new int[]{0, 100}, new int[]{14, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 114}, new int[]{0, 39}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 99}, new int[]{2, 1}, new int[]{0, 84}, new int[]{0, 85}, new int[]{2, 1}, new int[]{0, 70}, new int[]{0, 115}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 55}, new int[]{0, 101}, new int[]{2, 1}, new int[]{0, 86}, new int[]{0, 116}, 
			new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 71}, new int[]{2, 1}, new int[]{0, 102}, new int[]{0, 117}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 87}, new int[]{0, 118}, new int[]{2, 1}, new int[]{0, 103}, new int[]{0, 119}};

            private static int[][] ValTab11 = {new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 0}, new int[]{2, 1}, new int[]{0, 16}, new int[]{0, 1}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 17}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 32}, new int[]{0, 2}, new int[]{0, 18}, new int[]{24, 1}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 33}, new int[]{2, 1}, new int[]{0, 34}, new int[]{2, 1}, new int[]{0, 48}, new int[]{0, 3}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 49}, new int[]{0, 19}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 50}, new int[]{0, 35}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 64}, new int[]{0, 4}, new int[]{2, 1}, new int[]{0, 65}, new int[]{0, 20}, new int[]{30, 1}, new int[]{16, 1}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 66}, new int[]{0, 36}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 51}, new int[]{0, 67}, new int[]{0, 80}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 52}, new int[]{0, 81}, new int[]{0, 97}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 22}, new int[]{2, 1}, new int[]{0, 6}, new int[]{0, 38}, new int[]{2, 1}, new int[]{0, 98}, new int[]{2, 1}, new int[]{0, 21}, new int[]{2, 1}, new int[]{0, 5}, new int[]{0, 82}, new int[]{16, 1}, new int[]{10, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 37}, new int[]{0, 68}, new int[]{0, 96}, new int[]{2, 1}, new int[]{0, 99}, new int[]{0, 54}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 112}, new int[]{0, 23}, new int[]{0, 113}, new int[]{16, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 7}, new int[]{0, 100}, new int[]{0, 114}, new int[]{2, 1}, new int[]{0, 39}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 83}, new int[]{0, 53}, new int[]{2, 1}, new int[]{0, 84}, new int[]{0, 69}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 70}, new int[]{0, 115}, new int[]{2, 1}, new int[]{0, 55}, new int[]{2, 1}, new int[]{0, 101}, new int[]{0, 86}, new int[]{10, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, 
			new int[]{0, 85}, new int[]{0, 87}, new int[]{0, 116}, new int[]{2, 1}, new int[]{0, 71}, new int[]{0, 102}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 117}, new int[]{0, 118}, new int[]{2, 1}, new int[]{0, 103}, new int[]{0, 119}};

            private static int[][] ValTab12 = {new int[]{12, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 16}, new int[]{0, 1}, new int[]{2, 1}, new int[]{0, 17}, new int[]{2, 1}, new int[]{0, 0}, new int[]{2, 1}, new int[]{0, 32}, new int[]{0, 2}, new int[]{16, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 33}, new int[]{0, 18}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 34}, new int[]{0, 49}, new int[]{2, 1}, new int[]{0, 19}, new int[]{2, 1}, new int[]{0, 48}, new int[]{2, 1}, new int[]{0, 3}, new int[]{0, 64}, new int[]{26, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 50}, new int[]{0, 35}, new int[]{2, 1}, new int[]{0, 65}, new int[]{0, 51}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 20}, new int[]{0, 66}, new int[]{2, 1}, new int[]{0, 36}, new int[]{2, 1}, new int[]{0, 4}, new int[]{0, 80}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 67}, new int[]{0, 52}, new int[]{2, 1}, new int[]{0, 81}, new int[]{0, 21}, new int[]{28, 1}, new int[]{14, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 82}, new int[]{0, 37}, new int[]{2, 1}, new int[]{0, 83}, new int[]{0, 53}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 96}, new int[]{0, 22}, new int[]{0, 97}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 98}, new int[]{0, 38}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 5}, new int[]{0, 6}, new int[]{0, 68}, new int[]{2, 1}, new int[]{0, 84}, new int[]{0, 69}, new int[]{18, 1}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 99}, new int[]{0, 54}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 112}, new int[]{0, 7}, new int[]{0, 113}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 23}, new int[]{0, 100}, new int[]{2, 1}, new int[]{0, 70}, new int[]{0, 114}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 39}, new int[]{2, 1}, new int[]{0, 85}, new int[]{0, 115}, new int[]{2, 1}, new int[]{0, 55}, new int[]{0, 86}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 101}, 
			new int[]{0, 116}, new int[]{2, 1}, new int[]{0, 71}, new int[]{0, 102}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 117}, new int[]{0, 87}, new int[]{2, 1}, new int[]{0, 118}, new int[]{2, 1}, new int[]{0, 103}, new int[]{0, 119}};

            private static int[][] ValTab13 = {new int[]{2, 1}, new int[]{0, 0}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 16}, new int[]{2, 1}, new int[]{0, 1}, new int[]{0, 17}, new int[]{28, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 32}, new int[]{0, 2}, new int[]{2, 1}, new int[]{0, 33}, new int[]{0, 18}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 34}, new int[]{0, 48}, new int[]{2, 1}, new int[]{0, 3}, new int[]{0, 49}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 19}, new int[]{2, 1}, new int[]{0, 50}, new int[]{0, 35}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 64}, new int[]{0, 4}, new int[]{0, 65}, new int[]{70, 1}, new int[]{28, 1}, new int[]{14, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 20}, new int[]{2, 1}, new int[]{0, 51}, new int[]{0, 66}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 36}, new int[]{0, 80}, new int[]{2, 1}, new int[]{0, 67}, new int[]{0, 52}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 81}, new int[]{0, 21}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 5}, new int[]{0, 82}, new int[]{2, 1}, new int[]{0, 37}, new int[]{2, 1}, new int[]{0, 68}, new int[]{0, 83}, new int[]{14, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 96}, new int[]{0, 6}, new int[]{2, 1}, new int[]{0, 97}, new int[]{0, 22}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 128}, new int[]{0, 8}, new int[]{0, 129}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 53}, new int[]{0, 98}, new int[]{2, 1}, new int[]{0, 38}, new int[]{0, 84}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 69}, new int[]{0, 99}, new int[]{2, 1}, new int[]{0, 54}, new int[]{0, 112}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 7}, new int[]{0, 85}, new int[]{0, 113}, new int[]{2, 1}, new int[]{0, 23}, new int[]{2, 1}, new int[]{0, 39}, new int[]{0, 55}, new int[]{72, 1}, new int[]{24, 1}, new int[]{12, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 24}, new int[]{0, 130}, new int[]{2, 1}, 
			new int[]{0, 40}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 100}, new int[]{0, 70}, new int[]{0, 114}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 132}, new int[]{0, 72}, new int[]{2, 1}, new int[]{0, 144}, new int[]{0, 9}, new int[]{2, 1}, new int[]{0, 145}, new int[]{0, 25}, new int[]{24, 1}, new int[]{14, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 115}, new int[]{0, 101}, new int[]{2, 1}, new int[]{0, 86}, new int[]{0, 116}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 71}, new int[]{0, 102}, new int[]{0, 131}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 56}, new int[]{2, 1}, new int[]{0, 117}, new int[]{0, 87}, new int[]{2, 1}, new int[]{0, 146}, new int[]{0, 41}, new int[]{14, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 103}, new int[]{0, 133}, new int[]{2, 1}, new int[]{0, 88}, new int[]{0, 57}, new int[]{2, 1}, new int[]{0, 147}, new int[]{2, 1}, new int[]{0, 73}, new int[]{0, 134}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 160}, new int[]{2, 1}, new int[]{0, 104}, new int[]{0, 10}, new int[]{2, 1}, new int[]{0, 161}, new int[]{0, 26}, new int[]{68, 1}, new int[]{24, 1}, new int[]{12, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 162}, new int[]{0, 42}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 149}, new int[]{0, 89}, new int[]{2, 1}, new int[]{0, 163}, new int[]{0, 58}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 74}, new int[]{0, 150}, new int[]{2, 1}, new int[]{0, 176}, new int[]{0, 11}, new int[]{2, 1}, new int[]{0, 177}, new int[]{0, 27}, new int[]{20, 1}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 178}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 118}, new int[]{0, 119}, new int[]{0, 148}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 135}, new int[]{0, 120}, new int[]{0, 164}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 105}, new int[]{0, 165}, new int[]{0, 43}, new int[]{12, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 
			90}, new int[]{0, 136}, new int[]{0, 179}, new int[]{2, 1}, new int[]{0, 59}, new int[]{2, 1}, new int[]{0, 121}, new int[]{0, 166}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 106}, new int[]{0, 180}, new int[]{0, 192}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 12}, new int[]{0, 152}, new int[]{0, 193}, new int[]{60, 1}, new int[]{22, 1}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 28}, new int[]{2, 1}, new int[]{0, 137}, new int[]{0, 181}, new int[]{2, 1}, new int[]{0, 91}, new int[]{0, 194}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 44}, new int[]{0, 60}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 182}, new int[]{0, 107}, new int[]{2, 1}, new int[]{0, 196}, new int[]{0, 76}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 168}, new int[]{0, 138}, new int[]{2, 1}, new int[]{0, 208}, new int[]{0, 13}, new int[]{2, 1}, new int[]{0, 209}, new int[]{2, 1}, new int[]{0, 75}, new int[]{2, 1}, new int[]{0, 151}, new int[]{0, 167}, new int[]{12, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 195}, new int[]{2, 1}, new int[]{0, 122}, new int[]{0, 153}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 197}, new int[]{0, 92}, new int[]{0, 183}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 29}, new int[]{0, 210}, new int[]{2, 1}, new int[]{0, 45}, new int[]{2, 1}, new int[]{0, 123}, new int[]{0, 211}, new int[]{52, 1}, new int[]{28, 1}, new int[]{12, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 61}, new int[]{0, 198}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 108}, new int[]{0, 169}, new int[]{2, 1}, new int[]{0, 154}, new int[]{0, 212}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 184}, new int[]{0, 139}, new int[]{2, 1}, new int[]{0, 77}, new int[]{0, 199}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 124}, new int[]{0, 213}, new int[]{2, 1}, new int[]{0, 93}, new int[]{0, 224}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 225}, new int[]{0, 30}, new int[]{4, 1}
			, new int[]{2, 1}, new int[]{0, 14}, new int[]{0, 46}, new int[]{0, 226}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 227}, new int[]{0, 109}, new int[]{2, 1}, new int[]{0, 140}, new int[]{0, 228}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 229}, new int[]{0, 186}, new int[]{0, 240}, new int[]{38, 1}, new int[]{16, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 241}, new int[]{0, 31}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 170}, new int[]{0, 155}, new int[]{0, 185}, new int[]{2, 1}, new int[]{0, 62}, new int[]{2, 1}, new int[]{0, 214}, new int[]{0, 200}, new int[]{12, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 78}, new int[]{2, 1}, new int[]{0, 215}, new int[]{0, 125}, new int[]{2, 1}, new int[]{0, 171}, new int[]{2, 1}, new int[]{0, 94}, new int[]{0, 201}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 15}, new int[]{2, 1}, new int[]{0, 156}, new int[]{0, 110}, new int[]{2, 1}, new int[]{0, 242}, new int[]{0, 47}, new int[]{32, 1}, new int[]{16, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 216}, new int[]{0, 141}, new int[]{0, 63}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 243}, new int[]{2, 1}, new int[]{0, 230}, new int[]{0, 202}, new int[]{2, 1}, new int[]{0, 244}, new int[]{0, 79}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 187}, new int[]{0, 172}, new int[]{2, 1}, new int[]{0, 231}, new int[]{0, 245}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 217}, new int[]{0, 157}, new int[]{2, 1}, new int[]{0, 95}, new int[]{0, 232}, new int[]{30, 1}, new int[]{12, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 111}, new int[]{2, 1}, new int[]{0, 246}, new int[]{0, 203}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 188}, new int[]{0, 173}, new int[]{0, 218}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 247}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 126}, new int[]{0, 127}, new int[]{0, 142}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 158}, new int[]{0, 174}
			, new int[]{0, 204}, new int[]{2, 1}, new int[]{0, 248}, new int[]{0, 143}, new int[]{18, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 219}, new int[]{0, 189}, new int[]{2, 1}, new int[]{0, 234}, new int[]{0, 249}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 159}, new int[]{0, 235}, new int[]{2, 1}, new int[]{0, 190}, new int[]{2, 1}, new int[]{0, 205}, new int[]{0, 250}, new int[]{14, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 221}, new int[]{0, 236}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 233}, new int[]{0, 175}, new int[]{0, 220}, new int[]{2, 1}, new int[]{0, 206}, new int[]{0, 251}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 191}, new int[]{0, 222}, new int[]{2, 1}, new int[]{0, 207}, new int[]{0, 238}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 223}, new int[]{0, 239}, new int[]{2, 1}, new int[]{0, 255}, new int[]{2, 1}, new int[]{0, 237}, new int[]{2, 1}, new int[]{0, 253}, new int[]{2, 1}, new int[]{0, 252}, new int[]{0, 254}};

            private static int[][] ValTab14 = { new int[] { 0, 0 } };

            private static int[][] ValTab15 = {new int[]{16, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 0}, new int[]{2, 1}, new int[]{0, 16}, new int[]{0, 1}, new int[]{2, 1}, new int[]{0, 17}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 32}, new int[]{0, 2}, new int[]{2, 1}, new int[]{0, 33}, new int[]{0, 18}, new int[]{50, 1}, new int[]{16, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 34}, new int[]{2, 1}, new int[]{0, 48}, new int[]{0, 49}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 19}, new int[]{2, 1}, new int[]{0, 3}, new int[]{0, 64}, new int[]{2, 1}, new int[]{0, 50}, new int[]{0, 35}, new int[]{14, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 4}, new int[]{0, 20}, new int[]{0, 65}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 51}, new int[]{0, 66}, new int[]{2, 1}, new int[]{0, 36}, new int[]{0, 67}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 52}, new int[]{2, 1}, new int[]{0, 80}, new int[]{0, 5}, new int[]{2, 1}, new int[]{0, 81}, new int[]{0, 21}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 82}, new int[]{0, 37}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 68}, new int[]{0, 83}, new int[]{0, 97}, new int[]{90, 1}, new int[]{36, 1}, new int[]{18, 1}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 53}, new int[]{2, 1}, new int[]{0, 96}, new int[]{0, 6}, new int[]{2, 1}, new int[]{0, 22}, new int[]{0, 98}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 38}, new int[]{0, 84}, new int[]{2, 1}, new int[]{0, 69}, new int[]{0, 99}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 54}, new int[]{2, 1}, new int[]{0, 112}, new int[]{0, 7}, new int[]{2, 1}, new int[]{0, 113}, new int[]{0, 85}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 23}, new int[]{0, 100}, new int[]{2, 1}, new int[]{0, 114}, new int[]{0, 39}, new int[]{24, 1}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 70}, new int[]{0, 115}, new int[]{2, 1}, new int[]{0, 55}, new int[]{0, 101}, new int[]{4, 1}
			, new int[]{2, 1}, new int[]{0, 86}, new int[]{0, 128}, new int[]{2, 1}, new int[]{0, 8}, new int[]{0, 116}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 129}, new int[]{0, 24}, new int[]{2, 1}, new int[]{0, 130}, new int[]{0, 40}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 71}, new int[]{0, 102}, new int[]{2, 1}, new int[]{0, 131}, new int[]{0, 56}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 117}, new int[]{0, 87}, new int[]{2, 1}, new int[]{0, 132}, new int[]{0, 72}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 144}, new int[]{0, 25}, new int[]{0, 145}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 146}, new int[]{0, 118}, new int[]{2, 1}, new int[]{0, 103}, new int[]{0, 41}, new int[]{92, 1}, new int[]{36, 1}, new int[]{18, 1}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 133}, new int[]{0, 88}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 9}, new int[]{0, 119}, new int[]{0, 147}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 57}, new int[]{0, 148}, new int[]{2, 1}, new int[]{0, 73}, new int[]{0, 134}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 104}, new int[]{2, 1}, new int[]{0, 160}, new int[]{0, 10}, new int[]{2, 1}, new int[]{0, 161}, new int[]{0, 26}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 162}, new int[]{0, 42}, new int[]{2, 1}, new int[]{0, 149}, new int[]{0, 89}, new int[]{26, 1}, new int[]{14, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 163}, new int[]{2, 1}, new int[]{0, 58}, new int[]{0, 135}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 120}, new int[]{0, 164}, new int[]{2, 1}, new int[]{0, 74}, new int[]{0, 150}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 105}, new int[]{0, 176}, new int[]{0, 177}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 27}, new int[]{0, 165}, new int[]{0, 178}, new int[]{14, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 90}, new int[]{0, 43}, new int[]{2, 1}, new int[]{0, 136}, new int[]{
			0, 151}, new int[]{2, 1}, new int[]{0, 179}, new int[]{2, 1}, new int[]{0, 121}, new int[]{0, 59}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 106}, new int[]{0, 180}, new int[]{2, 1}, new int[]{0, 75}, new int[]{0, 193}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 152}, new int[]{0, 137}, new int[]{2, 1}, new int[]{0, 28}, new int[]{0, 181}, new int[]{80, 1}, new int[]{34, 1}, new int[]{16, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 91}, new int[]{0, 44}, new int[]{0, 194}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 11}, new int[]{0, 192}, new int[]{0, 166}, new int[]{2, 1}, new int[]{0, 167}, new int[]{0, 122}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 195}, new int[]{0, 60}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 12}, new int[]{0, 153}, new int[]{0, 182}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 107}, new int[]{0, 196}, new int[]{2, 1}, new int[]{0, 76}, new int[]{0, 168}, new int[]{20, 1}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 138}, new int[]{0, 197}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 208}, new int[]{0, 92}, new int[]{0, 209}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 183}, new int[]{0, 123}, new int[]{2, 1}, new int[]{0, 29}, new int[]{2, 1}, new int[]{0, 13}, new int[]{0, 45}, new int[]{12, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 210}, new int[]{0, 211}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 61}, new int[]{0, 198}, new int[]{2, 1}, new int[]{0, 108}, new int[]{0, 169}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 154}, new int[]{0, 184}, new int[]{0, 212}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 139}, new int[]{0, 77}, new int[]{2, 1}, new int[]{0, 199}, new int[]{0, 124}, new int[]{68, 1}, new int[]{34, 1}, new int[]{18, 1}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 213}, new int[]{0, 93}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 224}, new int[]{0, 14}, new int[]{0, 
			225}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 30}, new int[]{0, 226}, new int[]{2, 1}, new int[]{0, 170}, new int[]{0, 46}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 185}, new int[]{0, 155}, new int[]{2, 1}, new int[]{0, 227}, new int[]{0, 214}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 109}, new int[]{0, 62}, new int[]{2, 1}, new int[]{0, 200}, new int[]{0, 140}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 228}, new int[]{0, 78}, new int[]{2, 1}, new int[]{0, 215}, new int[]{0, 125}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 229}, new int[]{0, 186}, new int[]{2, 1}, new int[]{0, 171}, new int[]{0, 94}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 201}, new int[]{0, 156}, new int[]{2, 1}, new int[]{0, 241}, new int[]{0, 31}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 240}, new int[]{0, 110}, new int[]{0, 242}, new int[]{2, 1}, new int[]{0, 47}, new int[]{0, 230}, new int[]{38, 1}, new int[]{18, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 216}, new int[]{0, 243}, new int[]{2, 1}, new int[]{0, 63}, new int[]{0, 244}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 79}, new int[]{2, 1}, new int[]{0, 141}, new int[]{0, 217}, new int[]{2, 1}, new int[]{0, 187}, new int[]{0, 202}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 172}, new int[]{0, 231}, new int[]{2, 1}, new int[]{0, 126}, new int[]{0, 245}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 157}, new int[]{0, 95}, new int[]{2, 1}, new int[]{0, 232}, new int[]{0, 142}, new int[]{2, 1}, new int[]{0, 246}, new int[]{0, 203}, new int[]{34, 1}, new int[]{18, 1}, new int[]{10, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 15}, new int[]{0, 174}, new int[]{0, 111}, new int[]{2, 1}, new int[]{0, 188}, new int[]{0, 218}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 173}, new int[]{0, 247}, new int[]{2, 1}, new int[]{0, 127}, new int[]{0, 233}, new int[]{8
			, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 158}, new int[]{0, 204}, new int[]{2, 1}, new int[]{0, 248}, new int[]{0, 143}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 219}, new int[]{0, 189}, new int[]{2, 1}, new int[]{0, 234}, new int[]{0, 249}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 159}, new int[]{0, 220}, new int[]{2, 1}, new int[]{0, 205}, new int[]{0, 235}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 190}, new int[]{0, 250}, new int[]{2, 1}, new int[]{0, 175}, new int[]{0, 221}, new int[]{14, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 236}, new int[]{0, 206}, new int[]{0, 251}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 191}, new int[]{0, 237}, new int[]{2, 1}, new int[]{0, 222}, new int[]{0, 252}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 207}, new int[]{0, 253}, new int[]{0, 238}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 223}, new int[]{0, 254}, new int[]{2, 1}, new int[]{0, 239}, new int[]{0, 255}};

            private static int[][] ValTab16 = {new int[]{2, 1}, new int[]{0, 0}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 16}, new int[]{2, 1}, new int[]{0, 1}, new int[]{0, 17}, new int[]{42, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 32}, new int[]{0, 2}, new int[]{2, 1}, new int[]{0, 33}, new int[]{0, 18}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 34}, new int[]{2, 1}, new int[]{0, 48}, new int[]{0, 3}, new int[]{2, 1}, new int[]{0, 49}, new int[]{0, 19}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 50}, new int[]{0, 35}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 64}, new int[]{0, 4}, new int[]{0, 65}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 20}, new int[]{2, 1}, new int[]{0, 51}, new int[]{0, 66}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 36}, new int[]{0, 80}, new int[]{2, 1}, new int[]{0, 67}, new int[]{0, 52}, new int[]{138, 1}, new int[]{40, 1}, new int[]{16, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 5}, new int[]{0, 21}, new int[]{0, 81}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 82}, new int[]{0, 37}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 68}, new int[]{0, 53}, new int[]{0, 83}, new int[]{10, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 96}, new int[]{0, 6}, new int[]{0, 97}, new int[]{2, 1}, new int[]{0, 22}, new int[]{0, 98}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 38}, new int[]{0, 84}, new int[]{2, 1}, new int[]{0, 69}, new int[]{0, 99}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 54}, new int[]{0, 112}, new int[]{0, 113}, new int[]{40, 1}, new int[]{18, 1}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 23}, new int[]{2, 1}, new int[]{0, 7}, new int[]{2, 1}, new int[]{0, 85}, new int[]{0, 100}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 114}, new int[]{0, 39}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 70}, new int[]{0, 101}, new int[]{0, 115}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 55}
			, new int[]{2, 1}, new int[]{0, 86}, new int[]{0, 8}, new int[]{2, 1}, new int[]{0, 128}, new int[]{0, 129}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 24}, new int[]{2, 1}, new int[]{0, 116}, new int[]{0, 71}, new int[]{2, 1}, new int[]{0, 130}, new int[]{2, 1}, new int[]{0, 40}, new int[]{0, 102}, new int[]{24, 1}, new int[]{14, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 131}, new int[]{0, 56}, new int[]{2, 1}, new int[]{0, 117}, new int[]{0, 132}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 72}, new int[]{0, 144}, new int[]{0, 145}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 25}, new int[]{2, 1}, new int[]{0, 9}, new int[]{0, 118}, new int[]{2, 1}, new int[]{0, 146}, new int[]{0, 41}, new int[]{14, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 133}, new int[]{0, 88}, new int[]{2, 1}, new int[]{0, 147}, new int[]{0, 57}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 160}, new int[]{0, 10}, new int[]{0, 26}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 162}, new int[]{2, 1}, new int[]{0, 103}, new int[]{2, 1}, new int[]{0, 87}, new int[]{0, 73}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 148}, new int[]{2, 1}, new int[]{0, 119}, new int[]{0, 134}, new int[]{2, 1}, new int[]{0, 161}, new int[]{2, 1}, new int[]{0, 104}, new int[]{0, 149}, new int[]{220, 1}, new int[]{126, 1}, new int[]{50, 1}, new int[]{26, 1}, new int[]{12, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 42}, new int[]{2, 1}, new int[]{0, 89}, new int[]{0, 58}, new int[]{2, 1}, new int[]{0, 163}, new int[]{2, 1}, new int[]{0, 135}, new int[]{0, 120}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 164}, new int[]{0, 74}, new int[]{2, 1}, new int[]{0, 150}, new int[]{0, 105}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 176}, new int[]{0, 11}, new int[]{0, 177}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 27}, new int[]{0, 178}, new int[]{2, 1}, new int[]{0, 43}, new int[]{2, 1}, new int[]{0, 165}, new int[]{0, 90}, new int[]
			{6, 1}, new int[]{2, 1}, new int[]{0, 179}, new int[]{2, 1}, new int[]{0, 166}, new int[]{0, 106}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 180}, new int[]{0, 75}, new int[]{2, 1}, new int[]{0, 12}, new int[]{0, 193}, new int[]{30, 1}, new int[]{14, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 181}, new int[]{0, 194}, new int[]{0, 44}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 167}, new int[]{0, 195}, new int[]{2, 1}, new int[]{0, 107}, new int[]{0, 196}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 29}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 136}, new int[]{0, 151}, new int[]{0, 59}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 209}, new int[]{0, 210}, new int[]{2, 1}, new int[]{0, 45}, new int[]{0, 211}, new int[]{18, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 30}, new int[]{0, 46}, new int[]{0, 226}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 121}, new int[]{0, 152}, new int[]{0, 192}, new int[]{2, 1}, new int[]{0, 28}, new int[]{2, 1}, new int[]{0, 137}, new int[]{0, 91}, new int[]{14, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 60}, new int[]{2, 1}, new int[]{0, 122}, new int[]{0, 182}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 76}, new int[]{0, 153}, new int[]{2, 1}, new int[]{0, 168}, new int[]{0, 138}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 13}, new int[]{2, 1}, new int[]{0, 197}, new int[]{0, 92}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 61}, new int[]{0, 198}, new int[]{2, 1}, new int[]{0, 108}, new int[]{0, 154}, new int[]{88, 1}, new int[]{86, 1}, new int[]{36, 1}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 139}, new int[]{0, 77}, new int[]{2, 1}, new int[]{0, 199}, new int[]{0, 124}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 213}, new int[]{0, 93}, new int[]{2, 1}, new int[]{0, 224}, new int[]{0, 14}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 227}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 208}, new int[]{0, 183}, 
			new int[]{0, 123}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 169}, new int[]{0, 184}, new int[]{0, 212}, new int[]{2, 1}, new int[]{0, 225}, new int[]{2, 1}, new int[]{0, 170}, new int[]{0, 185}, new int[]{24, 1}, new int[]{10, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 155}, new int[]{0, 214}, new int[]{0, 109}, new int[]{2, 1}, new int[]{0, 62}, new int[]{0, 200}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 140}, new int[]{0, 228}, new int[]{0, 78}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 215}, new int[]{0, 229}, new int[]{2, 1}, new int[]{0, 186}, new int[]{0, 171}, new int[]{12, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 156}, new int[]{0, 230}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 110}, new int[]{0, 216}, new int[]{2, 1}, new int[]{0, 141}, new int[]{0, 187}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 231}, new int[]{0, 157}, new int[]{2, 1}, new int[]{0, 232}, new int[]{0, 142}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 203}, new int[]{0, 188}, new int[]{0, 158}, new int[]{0, 241}, new int[]{2, 1}, new int[]{0, 31}, new int[]{2, 1}, new int[]{0, 15}, new int[]{0, 47}, new int[]{66, 1}, new int[]{56, 1}, new int[]{2, 1}, new int[]{0, 242}, new int[]{52, 1}, new int[]{50, 1}, new int[]{20, 1}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 189}, new int[]{2, 1}, new int[]{0, 94}, new int[]{2, 1}, new int[]{0, 125}, new int[]{0, 201}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 202}, new int[]{2, 1}, new int[]{0, 172}, new int[]{0, 126}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 218}, new int[]{0, 173}, new int[]{0, 204}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 174}, new int[]{2, 1}, new int[]{0, 219}, new int[]{0, 220}, new int[]{2, 1}, new int[]{0, 205}, new int[]{0, 190}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 235}, new int[]{0, 237}, new int[]{0, 238}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 
			217}, new int[]{0, 234}, new int[]{0, 233}, new int[]{2, 1}, new int[]{0, 222}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 221}, new int[]{0, 236}, new int[]{0, 206}, new int[]{0, 63}, new int[]{0, 240}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 243}, new int[]{0, 244}, new int[]{2, 1}, new int[]{0, 79}, new int[]{2, 1}, new int[]{0, 245}, new int[]{0, 95}, new int[]{10, 1}, new int[]{2, 1}, new int[]{0, 255}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 246}, new int[]{0, 111}, new int[]{2, 1}, new int[]{0, 247}, new int[]{0, 127}, new int[]{12, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 143}, new int[]{2, 1}, new int[]{0, 248}, new int[]{0, 249}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 159}, new int[]{0, 250}, new int[]{0, 175}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 251}, new int[]{0, 191}, new int[]{2, 1}, new int[]{0, 252}, new int[]{0, 207}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 253}, new int[]{0, 223}, new int[]{2, 1}, new int[]{0, 254}, new int[]{0, 239}};

            private static int[][] ValTab24 = {new int[]{60, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 0}, new int[]{0, 16}, new int[]{2, 1}, new int[]{0, 1}, new int[]{0, 17}, new int[]{14, 1}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 32}, new int[]{0, 2}, new int[]{0, 33}, new int[]{2, 1}, new int[]{0, 18}, new int[]{2, 1}, new int[]{0, 34}, new int[]{2, 1}, new int[]{0, 48}, new int[]{0, 3}, new int[]{14, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 49}, new int[]{0, 19}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 50}, new int[]{0, 35}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 64}, new int[]{0, 4}, new int[]{0, 65}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 20}, new int[]{0, 51}, new int[]{2, 1}, new int[]{0, 66}, new int[]{0, 36}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 67}, new int[]{0, 52}, new int[]{0, 81}, new int[]{6, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 80}, new int[]{0, 5}, new int[]{0, 21}, new int[]{2, 1}, new int[]{0, 82}, new int[]{0, 37}, new int[]{250, 1}, new int[]{98, 1}, new int[]{34, 1}, new int[]{18, 1}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 68}, new int[]{0, 83}, new int[]{2, 1}, new int[]{0, 53}, new int[]{2, 1}, new int[]{0, 96}, new int[]{0, 6}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 97}, new int[]{0, 22}, new int[]{2, 1}, new int[]{0, 98}, new int[]{0, 38}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 84}, new int[]{0, 69}, new int[]{2, 1}, new int[]{0, 99}, new int[]{0, 54}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 113}, new int[]{0, 85}, new int[]{2, 1}, new int[]{0, 100}, new int[]{0, 70}, new int[]{32, 1}, new int[]{14, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 114}, new int[]{2, 1}, new int[]{0, 39}, new int[]{0, 55}, new int[]{2, 1}, new int[]{0, 115}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 112}, new int[]{0, 7}, new int[]{0, 23}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, 
			new int[]{0, 101}, new int[]{0, 86}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 128}, new int[]{0, 8}, new int[]{0, 129}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 116}, new int[]{0, 71}, new int[]{2, 1}, new int[]{0, 24}, new int[]{0, 130}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 40}, new int[]{0, 102}, new int[]{2, 1}, new int[]{0, 131}, new int[]{0, 56}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 117}, new int[]{0, 87}, new int[]{2, 1}, new int[]{0, 132}, new int[]{0, 72}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 145}, new int[]{0, 25}, new int[]{2, 1}, new int[]{0, 146}, new int[]{0, 118}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 103}, new int[]{0, 41}, new int[]{2, 1}, new int[]{0, 133}, new int[]{0, 88}, new int[]{92, 1}, new int[]{34, 1}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 147}, new int[]{0, 57}, new int[]{2, 1}, new int[]{0, 148}, new int[]{0, 73}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 119}, new int[]{0, 134}, new int[]{2, 1}, new int[]{0, 104}, new int[]{0, 161}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 162}, new int[]{0, 42}, new int[]{2, 1}, new int[]{0, 149}, new int[]{0, 89}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 163}, new int[]{0, 58}, new int[]{2, 1}, new int[]{0, 135}, new int[]{2, 1}, new int[]{0, 120}, new int[]{0, 74}, new int[]{22, 1}, new int[]{12, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 164}, new int[]{0, 150}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 105}, new int[]{0, 177}, new int[]{2, 1}, new int[]{0, 27}, new int[]{0, 165}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 178}, new int[]{2, 1}, new int[]{0, 90}, new int[]{0, 43}, new int[]{2, 1}, new int[]{0, 136}, new int[]{0, 179}, new int[]{16, 1}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 144}, new int[]{2, 1}, new int[]{0, 9}, new int[]{0, 160}, new int[]{2, 1}, new int[]{0, 151}, new int[]{0, 121}, new int[]
			{4, 1}, new int[]{2, 1}, new int[]{0, 166}, new int[]{0, 106}, new int[]{0, 180}, new int[]{12, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 26}, new int[]{2, 1}, new int[]{0, 10}, new int[]{0, 176}, new int[]{2, 1}, new int[]{0, 59}, new int[]{2, 1}, new int[]{0, 11}, new int[]{0, 192}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 75}, new int[]{0, 193}, new int[]{2, 1}, new int[]{0, 152}, new int[]{0, 137}, new int[]{67, 1}, new int[]{34, 1}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 28}, new int[]{0, 181}, new int[]{2, 1}, new int[]{0, 91}, new int[]{0, 194}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 44}, new int[]{0, 167}, new int[]{2, 1}, new int[]{0, 122}, new int[]{0, 195}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 60}, new int[]{2, 1}, new int[]{0, 12}, new int[]{0, 208}, new int[]{2, 1}, new int[]{0, 182}, new int[]{0, 107}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 196}, new int[]{0, 76}, new int[]{2, 1}, new int[]{0, 153}, new int[]{0, 168}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 138}, new int[]{0, 197}, new int[]{2, 1}, new int[]{0, 92}, new int[]{0, 209}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 183}, new int[]{0, 123}, new int[]{2, 1}, new int[]{0, 29}, new int[]{0, 210}, new int[]{9, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 45}, new int[]{0, 211}, new int[]{2, 1}, new int[]{0, 61}, new int[]{0, 198}, new int[]{85, 250}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 108}, new int[]{0, 169}, new int[]{2, 1}, new int[]{0, 154}, new int[]{0, 212}, new int[]{32, 1}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 184}, new int[]{0, 139}, new int[]{2, 1}, new int[]{0, 77}, new int[]{0, 199}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 124}, new int[]{0, 213}, new int[]{2, 1}, new int[]{0, 93}, new int[]{0, 225}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 30}, new int[]{0, 226}, new int[]{2, 1
			}, new int[]{0, 170}, new int[]{0, 185}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 155}, new int[]{0, 227}, new int[]{2, 1}, new int[]{0, 214}, new int[]{0, 109}, new int[]{20, 1}, new int[]{10, 1}, new int[]{6, 1}, new int[]{2, 1}, new int[]{0, 62}, new int[]{2, 1}, new int[]{0, 46}, new int[]{0, 78}, new int[]{2, 1}, new int[]{0, 200}, new int[]{0, 140}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 228}, new int[]{0, 215}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 125}, new int[]{0, 171}, new int[]{0, 229}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 186}, new int[]{0, 94}, new int[]{2, 1}, new int[]{0, 201}, new int[]{2, 1}, new int[]{0, 156}, new int[]{0, 110}, new int[]{8, 1}, new int[]{2, 1}, new int[]{0, 230}, new int[]{2, 1}, new int[]{0, 13}, new int[]{2, 1}, new int[]{0, 224}, new int[]{0, 14}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 216}, new int[]{0, 141}, new int[]{2, 1}, new int[]{0, 187}, new int[]{0, 202}, new int[]{74, 1}, new int[]{2, 1}, new int[]{0, 255}, new int[]{64, 1}, new int[]{58, 1}, new int[]{32, 1}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 172}, new int[]{0, 231}, new int[]{2, 1}, new int[]{0, 126}, new int[]{0, 217}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 157}, new int[]{0, 232}, new int[]{2, 1}, new int[]{0, 142}, new int[]{0, 203}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 188}, new int[]{0, 218}, new int[]{2, 1}, new int[]{0, 173}, new int[]{0, 233}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 158}, new int[]{0, 204}, new int[]{2, 1}, new int[]{0, 219}, new int[]{0, 189}, new int[]{16, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 234}, new int[]{0, 174}, new int[]{2, 1}, new int[]{0, 220}, new int[]{0, 205}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 235}, new int[]{0, 190}, new int[]{2, 1}, new int[]{0, 221}, new int[]{0, 236}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 206}, new int[]{0, 237}, new int[]
			{2, 1}, new int[]{0, 222}, new int[]{0, 238}, new int[]{0, 15}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 240}, new int[]{0, 31}, new int[]{0, 241}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 242}, new int[]{0, 47}, new int[]{2, 1}, new int[]{0, 243}, new int[]{0, 63}, new int[]{18, 1}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 244}, new int[]{0, 79}, new int[]{2, 1}, new int[]{0, 245}, new int[]{0, 95}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 246}, new int[]{0, 111}, new int[]{2, 1}, new int[]{0, 247}, new int[]{2, 1}, new int[]{0, 127}, new int[]{0, 143}, new int[]{10, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 248}, new int[]{0, 249}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 159}, new int[]{0, 175}, new int[]{0, 250}, new int[]{8, 1}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 251}, new int[]{0, 191}, new int[]{2, 1}, new int[]{0, 252}, new int[]{0, 207}, new int[]{4, 1}, new int[]{2, 1}, new int[]{0, 253}, new int[]{0, 223}, new int[]{2, 1}, new int[]{0, 254}, new int[]{0, 239}};
            private static int[][] ValTab32 = { new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 8 }, new int[] { 0, 4 }, new int[] { 2, 1 }, new int[] { 0, 1 }, new int[] { 0, 2 }, new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 12 }, new int[] { 0, 10 }, new int[] { 2, 1 }, new int[] { 0, 3 }, new int[] { 0, 6 }, new int[] { 6, 1 }, new int[] { 2, 1 }, new int[] { 0, 9 }, new int[] { 2, 1 }, new int[] { 0, 5 }, new int[] { 0, 7 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 14 }, new int[] { 0, 13 }, new int[] { 2, 1 }, new int[] { 0, 15 }, new int[] { 0, 11 } };
            private static int[][] ValTab33 = { new int[] { 16, 1 }, new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 0 }, new int[] { 0, 1 }, new int[] { 2, 1 }, new int[] { 0, 2 }, new int[] { 0, 3 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 4 }, new int[] { 0, 5 }, new int[] { 2, 1 }, new int[] { 0, 6 }, new int[] { 0, 7 }, new int[] { 8, 1 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 8 }, new int[] { 0, 9 }, new int[] { 2, 1 }, new int[] { 0, 10 }, new int[] { 0, 11 }, new int[] { 4, 1 }, new int[] { 2, 1 }, new int[] { 0, 12 }, new int[] { 0, 13 }, new int[] { 2, 1 }, new int[] { 0, 14 }, new int[] { 0, 15 } };
            public static HuffmanTable[] ht = null;
            private static int[] bitbuf;

            #region Constructor

            static HuffmanTable()
            {
                bitbuf = new int[32];
            }

            private HuffmanTable(System.String S, int XLEN, int YLEN, int LINBITS, int LINMAX, int REF, int[] TABLE, int[] HLEN, int[][] VAL, int TREELEN)
            {
                tablename0 = S[0];
                tablename1 = S[1];
                tablename2 = S[2];
                xlen = XLEN;
                ylen = YLEN;
                linbits = LINBITS;
                linmax = LINMAX;
                ref_Renamed = REF;
                table = TABLE;
                hlen = HLEN;
                val = VAL;
                treelen = TREELEN;
            }

            #endregion

            #region Public Methods

            public static int huffman_decoder(HuffmanTable h, int[] x, int[] y, int[] v, int[] w, BitReserve br)
            {
                int dmask = 1 << ((4 * 8) - 1);
                int level;
                int point = 0;
                int error = 1;
                level = dmask;

                if (h.val == null)
                    return 2;

                if (h.treelen == 0)
                {
                    x[0] = y[0] = 0;
                    return 0;
                }

                do
                {
                    if (h.val[point][0] == 0)
                    {
                        x[0] = Util.URShift(h.val[point][1], 4);
                        y[0] = h.val[point][1] & 0xf;
                        error = 0;
                        break;
                    }

                    if (br.Hget1bit() != 0)
                    {
                        while (h.val[point][1] >= MXOFF)
                            point += h.val[point][1];
                        point += h.val[point][1];
                    }
                    else
                    {
                        while (h.val[point][0] >= MXOFF)
                            point += h.val[point][0];
                        point += h.val[point][0];
                    }
                    level = Util.URShift(level, 1);

                }
                while ((level != 0) || (point < 0));

                if (h.tablename0 == '3' && (h.tablename1 == '2' || h.tablename1 == '3'))
                {
                    v[0] = (y[0] >> 3) & 1;
                    w[0] = (y[0] >> 2) & 1;
                    x[0] = (y[0] >> 1) & 1;
                    y[0] = y[0] & 1;

                    if (v[0] != 0)
                        if (br.Hget1bit() != 0)
                            v[0] = -v[0];
                    if (w[0] != 0)
                        if (br.Hget1bit() != 0)
                            w[0] = -w[0];
                    if (x[0] != 0)
                        if (br.Hget1bit() != 0)
                            x[0] = -x[0];
                    if (y[0] != 0)
                        if (br.Hget1bit() != 0)
                            y[0] = -y[0];
                }
                else
                {
                    if (h.linbits != 0)
                        if ((h.xlen - 1) == x[0])
                            x[0] += br.Hgetbits(h.linbits);
                    if (x[0] != 0)
                        if (br.Hget1bit() != 0)
                            x[0] = -x[0];
                    if (h.linbits != 0)
                        if ((h.ylen - 1) == y[0])
                            y[0] += br.Hgetbits(h.linbits);
                    if (y[0] != 0)
                        if (br.Hget1bit() != 0)
                            y[0] = -y[0];
                }
                return error;
            }

            public static void inithuff()
            {

                if (ht != null)
                    return;

                ht = new HuffmanTable[HTN];
                ht[0] = new HuffmanTable("0  ", 0, 0, 0, 0, -1, null, null, ValTab0, 0);
                ht[1] = new HuffmanTable("1  ", 2, 2, 0, 0, -1, null, null, ValTab1, 7);
                ht[2] = new HuffmanTable("2  ", 3, 3, 0, 0, -1, null, null, ValTab2, 17);
                ht[3] = new HuffmanTable("3  ", 3, 3, 0, 0, -1, null, null, ValTab3, 17);
                ht[4] = new HuffmanTable("4  ", 0, 0, 0, 0, -1, null, null, ValTab4, 0);
                ht[5] = new HuffmanTable("5  ", 4, 4, 0, 0, -1, null, null, ValTab5, 31);
                ht[6] = new HuffmanTable("6  ", 4, 4, 0, 0, -1, null, null, ValTab6, 31);
                ht[7] = new HuffmanTable("7  ", 6, 6, 0, 0, -1, null, null, ValTab7, 71);
                ht[8] = new HuffmanTable("8  ", 6, 6, 0, 0, -1, null, null, ValTab8, 71);
                ht[9] = new HuffmanTable("9  ", 6, 6, 0, 0, -1, null, null, ValTab9, 71);
                ht[10] = new HuffmanTable("10 ", 8, 8, 0, 0, -1, null, null, ValTab10, 127);
                ht[11] = new HuffmanTable("11 ", 8, 8, 0, 0, -1, null, null, ValTab11, 127);
                ht[12] = new HuffmanTable("12 ", 8, 8, 0, 0, -1, null, null, ValTab12, 127);
                ht[13] = new HuffmanTable("13 ", 16, 16, 0, 0, -1, null, null, ValTab13, 511);
                ht[14] = new HuffmanTable("14 ", 0, 0, 0, 0, -1, null, null, ValTab14, 0);
                ht[15] = new HuffmanTable("15 ", 16, 16, 0, 0, -1, null, null, ValTab15, 511);
                ht[16] = new HuffmanTable("16 ", 16, 16, 1, 1, -1, null, null, ValTab16, 511);
                ht[17] = new HuffmanTable("17 ", 16, 16, 2, 3, 16, null, null, ValTab16, 511);
                ht[18] = new HuffmanTable("18 ", 16, 16, 3, 7, 16, null, null, ValTab16, 511);
                ht[19] = new HuffmanTable("19 ", 16, 16, 4, 15, 16, null, null, ValTab16, 511);
                ht[20] = new HuffmanTable("20 ", 16, 16, 6, 63, 16, null, null, ValTab16, 511);
                ht[21] = new HuffmanTable("21 ", 16, 16, 8, 255, 16, null, null, ValTab16, 511);
                ht[22] = new HuffmanTable("22 ", 16, 16, 10, 1023, 16, null, null, ValTab16, 511);
                ht[23] = new HuffmanTable("23 ", 16, 16, 13, 8191, 16, null, null, ValTab16, 511);
                ht[24] = new HuffmanTable("24 ", 16, 16, 4, 15, -1, null, null, ValTab24, 512);
                ht[25] = new HuffmanTable("25 ", 16, 16, 5, 31, 24, null, null, ValTab24, 512);
                ht[26] = new HuffmanTable("26 ", 16, 16, 6, 63, 24, null, null, ValTab24, 512);
                ht[27] = new HuffmanTable("27 ", 16, 16, 7, 127, 24, null, null, ValTab24, 512);
                ht[28] = new HuffmanTable("28 ", 16, 16, 8, 255, 24, null, null, ValTab24, 512);
                ht[29] = new HuffmanTable("29 ", 16, 16, 9, 511, 24, null, null, ValTab24, 512);
                ht[30] = new HuffmanTable("30 ", 16, 16, 11, 2047, 24, null, null, ValTab24, 512);
                ht[31] = new HuffmanTable("31 ", 16, 16, 13, 8191, 24, null, null, ValTab24, 512);
                ht[32] = new HuffmanTable("32 ", 1, 16, 0, 0, -1, null, null, ValTab32, 31);
                ht[33] = new HuffmanTable("33 ", 1, 16, 0, 0, -1, null, null, ValTab33, 31);
            }

            #endregion

        }

        internal class BitReserve
        {
            private const int BUFSIZE = 4096 * 8;
            private static readonly int BUFSIZE_MASK = BUFSIZE - 1;
            private int offset, totbit, buf_byte_idx;
            private int[] buf;

            #region Constructors

            internal BitReserve()
            {
                this.InitBlock();

                this.offset = 0;
                this.totbit = 0;
                this.buf_byte_idx = 0;
            }

            #endregion

            #region Public Methods

            public int Hsstell()
            {
                return this.totbit;
            }

            public int Hgetbits(int n)
            {
                this.totbit += n;

                int val = 0;

                int pos = this.buf_byte_idx;
                if (pos + n < BUFSIZE)
                {
                    while (n-- > 0)
                    {
                        val <<= 1;
                        val |= (this.buf[pos++] != 0) ? 1 : 0;
                    }
                }
                else
                {
                    while (n-- > 0)
                    {
                        val <<= 1;
                        val |= (this.buf[pos] != 0) ? 1 : 0;
                        pos = (pos + 1) & BUFSIZE_MASK;
                    }
                }

                this.buf_byte_idx = pos;
                return val;
            }

            public int Hget1bit()
            {
                this.totbit++;
                int val = this.buf[this.buf_byte_idx];
                this.buf_byte_idx = (this.buf_byte_idx + 1) & BUFSIZE_MASK;
                return val;
            }

            public void Hputbuf(int val)
            {
                int ofs = this.offset;
                this.buf[ofs++] = val & 0x80;
                this.buf[ofs++] = val & 0x40;
                this.buf[ofs++] = val & 0x20;
                this.buf[ofs++] = val & 0x10;
                this.buf[ofs++] = val & 0x08;
                this.buf[ofs++] = val & 0x04;
                this.buf[ofs++] = val & 0x02;
                this.buf[ofs++] = val & 0x01;

                if (ofs == BUFSIZE)
                {
                    this.offset = 0;
                }
                else
                {
                    this.offset = ofs;
                }
            }

            public void RewindNbits(int n)
            {
                this.totbit -= n;
                this.buf_byte_idx -= n;
                if (this.buf_byte_idx < 0)
                {
                    this.buf_byte_idx += BUFSIZE;
                }
            }

            public void RewindNbytes(int n)
            {
                int bits = n << 3;
                this.totbit -= bits;
                this.buf_byte_idx -= bits;
                if (this.buf_byte_idx < 0)
                {
                    this.buf_byte_idx += BUFSIZE;
                }
            }

            #endregion

            #region Private Methods

            /// <summary>
            /// Inicia um bloco
            /// </summary>
            private void InitBlock()
            {
                this.buf = new int[BUFSIZE];
            }

            #endregion
        }
        #endregion

        #region Static Methods
        private static float[] create_t_43()
        {
            float[] t43 = new float[8192];
            double d43 = (4.0 / 3.0);

            for (int i = 0; i < 8192; i++)
            {
                t43[i] = (float)System.Math.Pow(i, d43);
            }
            return t43;
        }
        #endregion

    }
}
